//*****************************************************************************************************
//  1. t@C
//		ManualEditView1.cpp
//----------------------------------------------------------------------------------------------------
//  2. @\
//		CManualEditView1 NX̃Cve[V
//----------------------------------------------------------------------------------------------------
//  3. l
//----------------------------------------------------------------------------------------------------
//  4. 
//		2006.09.01 S.Aizawa(xxx) VK쐬
//*****************************************************************************************************

#include "stdafx.h"
#include "workscheduler.h"

#include "MenuDispCtrl.h"

#include "ManualEditWnd002.h"
#include "ManualEditView1.h"
#include "DataManager.h"
#include "ManualMoveDlg.h"
#include "ManualBunkatsuDlg.h"
#include "ManualEditDlg.h"
#include "ManualDstrDlg.h"
#include "SplitterEx.h"
#include "ManualEditChildWnd.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define JIDO_SIZE	6		// H̎Op\̃TCY

// }EXړ[h
#define MOUSE_NONE		0
#define MOUSE_SELECT	1
#define MOUSE_DRAG		2

// Modify ... ( ADD )
#define MOVE_IVENT_NONE			0
#define MOVE_IVENT_MOVE			1
#define MOVE_IVENT_KITCANCEL	2
// By Y.Itabashi (xxxxx) 2007.03.05

IMPLEMENT_DYNCREATE(CManualEditView1, CManualEditView)

//*****************************************************************************************************
//  1. ֐
//		CManualEditView1::CManualEditView1
//----------------------------------------------------------------------------------------------------
//  2. @\
//		RXgN^
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//----------------------------------------------------------------------------------------------------
//  5. Tv
//		NXϐB
//----------------------------------------------------------------------------------------------------
//  6. l
//----------------------------------------------------------------------------------------------------
//  7. 
//		2006.09.01 S.Aizawa(xxx) VK쐬
//*****************************************************************************************************
CManualEditView1::CManualEditView1()
{
	// NXϐ̏
	m_pRightClickZahyo = NULL;
	m_nMouseMoveMode = MOUSE_NONE;
	m_nSelectRemoveIndex = -1;
// Modify ... ( CHANGE )
	m_rectNewMove.SetRectEmpty();
//	m_rectNewMove = 0;
// By Y.Itabashi (xxxxx) 2007.02.11

	// XP[p[^ݒ
	SetScaleParamaeter();

	// hbO̎Op`悷uV쐬
	m_brushMoveDrag.CreateSolidBrush(RGB(0, 0xff, 0xff));

	m_penSelected.CreatePen(PS_SOLID, 2, g_pSystem->m_cIniUser.m_rgbSelectProcessColor);
	m_penNewMove.CreatePen(PS_SOLID, 2, g_pSystem->m_cIniUser.m_rgbNewMoveProcessColor);
	m_penKittingCancel.CreatePen(PS_DOT, 1, g_pSystem->m_cIniUser.m_rgbKittingCancelProcessColor);
// Modify ... ( ADD )
	m_penReference.CreatePen(PS_DOT, 2, g_pSystem->m_cIniUser.m_rgbReferenceProcessColor);
// By Y.Itabashi (xxxxx) 2007.02.27

	// ʍH̃rbg}bv
	BITMAP bmp;
	m_bmpKyotsuKotei.LoadBitmap(IDB_BITMAP_KYOTSU_KOTEI);
	m_bmpKyotsuKotei.GetBitmap(&bmp);
	m_sizeKyotsuKotei.cx = bmp.bmWidth;
	m_sizeKyotsuKotei.cy = bmp.bmHeight;
}


BEGIN_MESSAGE_MAP(CManualEditView1, CManualEditView)
	//{{AFX_MSG_MAP(CManualEditView1)
	ON_WM_RBUTTONDOWN()
	ON_COMMAND(IDM_MANUAL_MOVE, OnManualMove)
	ON_COMMAND(IDM_MANUAL_BUNKATSU, OnManualBunkatsu)
	ON_COMMAND(IDM_MANUAL_EDIT, OnManualEdit)
	ON_WM_LBUTTONDOWN()
	ON_WM_MOUSEMOVE()
	ON_WM_LBUTTONUP()
	ON_WM_CHAR()
	ON_WM_LBUTTONDBLCLK()
	ON_WM_SIZE()
	ON_COMMAND(IDM_MANUAL_SAGYOSHA_MAE, OnManualSagyoshaMae)
	ON_COMMAND(IDM_MANUAL_SAGYOSHA_USHIRO, OnManualSagyoshaUshiro)
	ON_COMMAND(IDM_MANUAL_SAGYOSHA_SAKUJO, OnManualSagyoshaSakujo)
	ON_COMMAND(IDM_MANUAL_COPY, OnManualCopy)
	ON_COMMAND(IDM_MANUAL_PASTE, OnManualPaste)
	ON_COMMAND(IDM_MANUAL_DSTR, OnManualDstr)
	//}}AFX_MSG_MAP
	ON_MESSAGE(WM_USER_DRAG, OnUserDrag)
END_MESSAGE_MAP()


//*****************************************************************************************************
//  1. ֐
//		CManualEditView1::OnInitialUpdate
//----------------------------------------------------------------------------------------------------
//  2. @\
//		r[
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//----------------------------------------------------------------------------------------------------
//  5. Tv
//		XN[o[\B
//----------------------------------------------------------------------------------------------------
//  6. l
//----------------------------------------------------------------------------------------------------
//  7. 
//		2006.09.01 S.Aizawa(xxx) VK쐬
//*****************************************************************************************************
void CManualEditView1::OnInitialUpdate()
{
	CManualEditView::OnInitialUpdate();

	SetWindowPos(&wndBottom, 0, 0, 0, 0, SWP_NOMOVE | SWP_NOSIZE);

	// ^Cgݒ
// Modify ... ( CHANGE )
	CString str = g_pSystem->m_cMenuDisp.GetMenu( Menu_ManualWindowTitle[1].MenuNo, Menu_ManualWindowTitle[1].ItemNo );
	GetParent()->GetParent()->SetWindowText( str );
//	GetParent()->SetWindowText("ҏW");
// By Y.Itabashi (xxxxx) 2007.01.26

	// ԂňԉɃXN[
	CRect rect;
	GetClientRect(rect);
	ScrollToPosition(CPoint(0, m_rectView.Height() - rect.Height()));

	DispSublineInfo();
}

//*****************************************************************************************************
//  1. ֐
//		CManualEditView1::OnDraw
//----------------------------------------------------------------------------------------------------
//  2. @\
//		r[
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		CDC		*pDC			[I] foCXReLXg
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//----------------------------------------------------------------------------------------------------
//  5. Tv
//		Ot̊ep[c`悷B
//----------------------------------------------------------------------------------------------------
//  6. l
//----------------------------------------------------------------------------------------------------
//  7. 
//		2006.09.01 S.Aizawa(xxx) VK쐬
//*****************************************************************************************************
void CManualEditView1::OnDraw(CDC* pDC)
{
	CManualEditDocument *pDoc = GetDocument();
	CFont *pFontOrg = pDC->SelectObject(g_pSystem->m_pMainDlg->GetFont());

	// `惂[hTRANSPARENTɐݒ
	int nBkMode = pDC->SetBkMode(TRANSPARENT);

	// ƃOt`
	DrawGraph(pDC, TRUE);

	// ʍHg`
	DrawKyotsuKoteiFrame(pDC);

	// ŐVړg`
	if (pDoc->m_bDispNewMove)
		DrawNewMoveFrame(pDC);

	// Lbgg`
	DrawKittingCancelFrame(pDC);

// Modify ... ( ADD )
	// QƍH`
	DrawReferenceFrame(pDC);
// By Y.Itabashi (xxxxx) 2007.02.27

	// c`
	DrawVerticalAxisLine(pDC);

	// `
	DrawHorizontalAxisLine(pDC);

	// ceLXg`
// Modify ... ( CHANGE )
	CString str = g_pSystem->m_cMenuDisp.GetMenu( Menu_ManualWindowText[0].MenuNo, Menu_ManualWindowText[0].ItemNo );
	DrawVerticalAxisText(pDC, str);
//	DrawVerticalAxisText(pDC, "yƎԁz");
// By Y.Itabashi (xxxxx) 2007.01.26

	// eLXg`
	DrawHorizontalAxisText(pDC);

	// vԕ`
	DrawTotalTime(pDC);

	// ڕW^Ng`
	DrawTactLine(pDC);

	// TuCԋ؂`
	DrawSublineBoundLine(pDC);

	// LbgTuCԋ؂`
	DrawKittingSubline(pDC);

	// `惂[h߂
	pDC->SetBkMode(nBkMode);

	pDC->SelectObject(pFontOrg);
}

//*****************************************************************************************************
//  1. ֐
//		CManualEditView1::OnUpdate
//----------------------------------------------------------------------------------------------------
//  2. @\
//		r[XV
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		CView		*pSender		[I] hLgCꂽr[ւ̃|C^
//		LPARAM		lHint			[I] ύXɂĂ̏
//		CObject		*pHint			[I] ύXɂĂ̏񂪊i[ꂽIuWFNg
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//----------------------------------------------------------------------------------------------------
//  5. Tv
//		r[ĕ`悷B
//----------------------------------------------------------------------------------------------------
//  6. l
//----------------------------------------------------------------------------------------------------
//  7. 
//		2006.09.01 S.Aizawa(xxx) VK쐬
//*****************************************************************************************************
void CManualEditView1::OnUpdate(CView* pSender, LPARAM lHint, CObject* pHint)
{
	CManualEditDocument *pDoc = GetDocument();
	CSplitterEx *pWnd = (CSplitterEx *)GetParent();
	CFrameWnd *pActiveFrame;

// Modify ... ( CHANGE )
	// @ύXőΏۉʈȊO̓Abvf[gȂ
	if( lHint == UPDATE_GRAPH_KISHU && pHint != GetParentFrame() ){
		Invalidate();
		return;
	}
// By Y.Itabashi (xxxxx) 2007.02.27

	switch (lHint) {
	case UPDATE_SCROLL:
		if (pWnd->IsActivePane(this)) {
			SZahyoSagyosha *pZahyoSagyosha = (SZahyoSagyosha *)pHint;
			DispCenterSagyosha(pZahyoSagyosha->nSublineId, pZahyoSagyosha->nSagyoshaId);
		}
		return;
// Modify ... ( ADD )
	case UPDATE_SCROLL_ACTIVE:
		pActiveFrame = ((CFrameWnd *)(AfxGetMainWnd()->GetActiveWindow()))->GetActiveFrame();
		if( pActiveFrame == GetParentFrame() ){
			if (pWnd->IsActivePane(this)) {
				SZahyoSagyosha *pZahyoSagyosha = (SZahyoSagyosha *)pHint;
				DispCenterSagyosha(pZahyoSagyosha->nSublineId, pZahyoSagyosha->nSagyoshaId);
			}
		}
		return;
// By Y.Itabashi (xxxxx) 2007.03.04
	case UPDATE_CHANGE_SLIM:
		break;
	case UPDATE_CHANGE_SUBLINE:
		InitializeZahyoData();
		break;
	case UPDATE_EDIT_VIEW:
		Invalidate(FALSE);
		return;
	case UPDATE_SELECT_BLINK:
		BlinkSelectedBox((BOOL)pHint);
		return;
	case UPDATE_ERASE_MOVE_TRIANGLE:
		DrawMoveTriangle(0);
		return;
	}

	// XP[p[^ݒ
	SetScaleParamaeter();
	SetSlimMode();

	// WvZ
	MakeGraph();

	// r[̈𖳌
	Invalidate();

	// TuC\
	DispSublineInfo();
}

//*****************************************************************************************************
//  1. ֐
//		CManualEditView1::OnSize
//----------------------------------------------------------------------------------------------------
//  2. @\
//		EBhETCYύX
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		UINT	nType			[I] TCYύX̃^Cv
//		int		cx				[I] EBhE̕
//		int		cy				[I] EBhE̍
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//----------------------------------------------------------------------------------------------------
//  5. Tv
//		EBhETCYɍ킹ăOt̍WČvZčĕ`悷B
//----------------------------------------------------------------------------------------------------
//  6. l
//----------------------------------------------------------------------------------------------------
//  7. 
//		2006.09.01 S.Aizawa(xxx) VK쐬
//*****************************************************************************************************
void CManualEditView1::OnSize(UINT nType, int cx, int cy)
{
	CManualEditView::OnSize(nType, cx, cy);

	if (m_bInitialize) {
		// Ot̍WČvZ
		MakeGraph();

		// TuC\ʒuݒ
		SetSublineInfoPos();

		// TuC\ 20070213 xxxxx kuwa
		DispSublineInfo();
	}
}

//*****************************************************************************************************
//  1. ֐
//		CManualEditView1::MakeGraph
//----------------------------------------------------------------------------------------------------
//  2. @\
//		Ot\f[^쐬
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//----------------------------------------------------------------------------------------------------
//  5. Tv
//		Ot`ɕKvȃf[^쐬B
//----------------------------------------------------------------------------------------------------
//  6. l
//----------------------------------------------------------------------------------------------------
//  7. 
//		2006.09.01 S.Aizawa(xxx) VK쐬
//*****************************************************************************************************
void CManualEditView1::MakeGraph()
{
	CManualEditDocument *pDoc = GetDocument();

	// r[TCYݒ
	SetViewSize();

	// Wf[^폜
	ClearZahyoData();
	m_aZahyoDrag.RemoveAll();
	m_aZahyoDrop.RemoveAll();
	m_aKittingCancel.RemoveAll();

	// TuCʂɃOt̍WvZ
	int nSublineBound = m_rectGraph.left;
	int nLeft = m_rectGraph.left + m_nLeftSpacing;
	int nGraphSublineNum = pDoc->m_aGraphSubline.GetSize();
	for (int nSublineIndex = 0; nSublineIndex < nGraphSublineNum; nSublineIndex++) {
		SGraphSubline &cGraphSubline = pDoc->m_aGraphSubline[nSublineIndex];

		if (cGraphSubline.nSublineId == -1) {
			nLeft += m_nBarSpacing;
			nSublineBound += m_nBarSpacing / 2;
			m_aZahyoSubline[nSublineIndex - 1].nRight = nSublineBound;
		}

		MakeGraphSub(cGraphSubline, nLeft);

		SZahyoSubline &cZahyoSubline = m_aZahyoSubline[nSublineIndex];
		cZahyoSubline.nSublineId = cGraphSubline.nSublineId;
		cZahyoSubline.nLeft = nSublineBound;
		nSublineBound = nLeft - m_nBarSpacing / 2;
		cZahyoSubline.nRight = nSublineBound;
	}

	// ŐVړ
// Modify ... ( CHANGE )
	m_rectNewMove.SetRectEmpty();
//	m_rectNewMove = 0;
// By Y.Itabashi (xxxxx) 2007.02.11
	int nSize = m_aZahyoDrag.GetSize();
	for (int i = 0; i < nSize; i++) {
		SZahyoDrag &cSZahyoDrag = m_aZahyoDrag[i];
		if (cSZahyoDrag.pGraphBlock->bNewMove)
			m_rectNewMove.UnionRect(m_rectNewMove, cSZahyoDrag.rect);
	}

// Modify ... ( CHANGE )
	// IZbg
	if( GetParentFrame() == GetDocument()->m_pSelectWnd )
		ResetSelectedBox();
//	ResetSelectedBox();
}

//*****************************************************************************************************
//  1. ֐
//		CManualEditView1::MakeGraphSub
//----------------------------------------------------------------------------------------------------
//  2. @\
//		Ot\f[^쐬
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		CGraphSagyoshaArray	&aGraphSagyosha		[I] OtƎҔz
//		int					&nLeft				[I/O] EBhE̕
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//----------------------------------------------------------------------------------------------------
//  5. Tv
//		Ot`ɕKvȃf[^쐬B
//----------------------------------------------------------------------------------------------------
//  6. l
//----------------------------------------------------------------------------------------------------
//  7. 
//		2006.09.01 S.Aizawa(xxx) VK쐬
//*****************************************************************************************************
void CManualEditView1::MakeGraphSub(SGraphSubline &cGraphSubline, int &nLeft)
{
	CManualEditDocument *pDoc = GetDocument();
// Modify ... ( CHANGE )
	int nTotalSeisanDaisu = g_pDataManager->GetTotalSeisanDaisu( cGraphSubline.nSublineId );
//	int nTotalSeisanDaisu = g_pDataManager->GetTotalSeisanDaisu();
// By Y.Itabashi (xxxxx) 2007.02.11
	CString sKyotsuKotei;
	int nKittingSublineId = -1;
	CRect rectSagyosha;
	SGraphBlock *pLastGraphBlock = NULL;

	CDC *pDC = GetDC();
	CFont *pFontOrg = pDC->SelectObject(&m_fontH);

	// ƎҕʂɃOt̍WvZ
	int nSagyoshaNum = cGraphSubline.aGraphSagyosha.GetSize();
	for (int i = 0; i < nSagyoshaNum; i++) {
		SGraphSagyosha &cGraphSagyosha = cGraphSubline.aGraphSagyosha[i];
		CGraphBlockArray &aGraphBlock = pDoc->m_nGraphKind == GRAPH_YOSO_SAGYOGUN ? cGraphSagyosha.aYosoSagyogun : cGraphSagyosha.aKotei;

		// Ot̍W
		MakeZahyoGraph(cGraphSubline.nSublineId, aGraphBlock, cGraphSagyosha.nSagyoshaId, nLeft, m_rectGraph.bottom, nKittingSublineId, pLastGraphBlock);

		// ƎҖ̍W
		CSize size = pDC->GetTextExtent(cGraphSagyosha.sSagyoshaName);
		rectSagyosha.left = nLeft + (m_nBarWidth - size.cx) / 2;
		rectSagyosha.top = m_rectGraph.bottom + 8;
		rectSagyosha.right = rectSagyosha.left + size.cx;
		rectSagyosha.bottom = rectSagyosha.top + size.cy;
		AddZahyoSagyosha(rectSagyosha, cGraphSubline.nSublineId, cGraphSagyosha.nSagyoshaId);


		if (!cGraphSagyosha.bKitting) {
			// ʍH}[N̍W
			if (GetSagyoshaKyotsuKotei(cGraphSagyosha, sKyotsuKotei)) {
				CRect rect;
				rect.left = rectSagyosha.right + 2;
				rect.top = rectSagyosha.top;
				rect.right = rect.left + m_sizeKyotsuKotei.cx;
				rect.bottom = rect.top + m_sizeKyotsuKotei.cy;
				AddZahyoGraph(rect, sKyotsuKotei, COORDINATE_KIND_KYOTSU_KOTEI);
			}
		}

		nLeft += m_nBarWidth + m_nBarSpacing;
	}

	pDC->SelectObject(pFontOrg);
	ReleaseDC(pDC);
}

BOOL CManualEditView1::GetSagyoshaKyotsuKotei(SGraphSagyosha &cGraphSagyosha, CString &sKyotsuKotei)
{
// Modify ... ( CHANGE )
	CManualEditChildWnd *pWnd = (CManualEditChildWnd *)GetParentFrame();
//	CManualEditDocument *pDoc = GetDocument();
// By Y.Itabashi (xxxxx) 207.02.26
	CStringArrayEx aKyotsuKotei;

// Modify ... ( CHANGE )
	if (pWnd->m_nGraphKishu == -1) {
//	if (pDoc->m_nGraphKishu == -1) {
// By Y.Itabashi (xxxxx) 207.02.26
		int nKishuNum = cGraphSagyosha.aKishu.GetSize();
		for (int nKishuId = 0; nKishuId < nKishuNum; nKishuId++)
			GetSagyoshaKyotsuKoteiSub(cGraphSagyosha, nKishuId, aKyotsuKotei);
	} else
// Modify ... ( CHANGE )
		GetSagyoshaKyotsuKoteiSub(cGraphSagyosha, pWnd->m_nGraphKishu, aKyotsuKotei);
//		GetSagyoshaKyotsuKoteiSub(cGraphSagyosha, pDoc->m_nGraphKishu, aKyotsuKotei);
// By Y.Itabashi (xxxxx) 2007.02.26

	aKyotsuKotei.Unique();
	sKyotsuKotei = aKyotsuKotei.Join("\n");

	return !sKyotsuKotei.IsEmpty();
}

void CManualEditView1::GetSagyoshaKyotsuKoteiSub(SGraphSagyosha &cGraphSagyosha, int nKishuId, CStringArrayEx &aKyotsuKotei)
{
	CManualEditDocument *pDoc = GetDocument();
	CString sKyotsuKotei;

	CGraphBlockArray &aGraphBlock = pDoc->m_nGraphKind == GRAPH_YOSO_SAGYOGUN ? cGraphSagyosha.aYosoSagyogun : cGraphSagyosha.aKotei;
	int nSize = aGraphBlock.GetSize();
	for (int i = 0; i < nSize; i++) {
		SGraphBlock &cGraphBlock = aGraphBlock[i];

		if (nKishuId == -1 || nKishuId == cGraphBlock.nKishuId) {
			if (cGraphBlock.bKyotsuKotei) {
				sKyotsuKotei = "E";

// Modify ... ( CHANGE )
				if (cGraphBlock.sJido == g_pConst->m_sJido){
					CString str = g_pSystem->m_cMenuDisp.GetMenu( Menu_ManualWindowText[8].MenuNo, Menu_ManualWindowText[8].ItemNo );
					sKyotsuKotei += str;
				}
				else if (cGraphBlock.sJido == g_pConst->m_sHanJido){
					CString str = g_pSystem->m_cMenuDisp.GetMenu( Menu_ManualWindowText[9].MenuNo, Menu_ManualWindowText[9].ItemNo );
					sKyotsuKotei += str;
				}
/*				if (cGraphBlock.sJido == g_pConst->m_sJido)
					sKyotsuKotei += ")";
				else if (cGraphBlock.sJido == g_pConst->m_sHanJido)
					sKyotsuKotei += ")";*/
// By Y.Itabashi (xxxxx) 2007.01.26

				sKyotsuKotei += pDoc->m_nGraphKind == GRAPH_YOSO_SAGYOGUN ? cGraphBlock.sYosoSagyogunName : cGraphBlock.sKoteiName;
				aKyotsuKotei.Add(sKyotsuKotei);
			}
		}
	}
}

//*****************************************************************************************************
//  1. ֐
//		CManualEditView1::MakeZahyoGraph
//----------------------------------------------------------------------------------------------------
//  2. @\
//		OtWf[^쐬
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		CGraphBlockArray	&aGraphBlock	[I] OtubNz
//		int					nSagyoshaId		[I] ƎID
//		int					nKishuId		[I] @ID
//		int					nLeft			[I] XW
//		int					nTop			[I] YW
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		int		lp`̉ӂ̍W
//----------------------------------------------------------------------------------------------------
//  5. Tv
//		H܂͗vfƌQ̎lp`̍WvZB
//----------------------------------------------------------------------------------------------------
//  6. l
//----------------------------------------------------------------------------------------------------
//  7. 
//		2006.09.01 S.Aizawa(xxx) VK쐬
//*****************************************************************************************************
void CManualEditView1::MakeZahyoGraph(int nSublineId, CGraphBlockArray &aGraphBlock, int nSagyoshaId, int nLeft, int nTop, int &nKittingSublineId, SGraphBlock *&pLastGraphBlock)
{
// Modify ... ( ADD )
	CManualEditChildWnd *pWnd = (CManualEditChildWnd *)GetParentFrame();
// By Y.Itabashi (xxxxx) 2007.02.26
	CManualEditDocument *pDoc = GetDocument();
	int i;
	double fBottom, fTop;
	CRect rect;
	CString sText;
	BOOL bJidoKyotsuKotei = FALSE;
	CRect rectJido;
	CStringArrayEx aJidoKoteiName;
	BOOL bHanJidoKyotsuKotei = FALSE;
	CRect rectHanJido;
	CStringArrayEx aHanJidoKoteiName;
	double fRatio;
	int nGroupNo = 0;
	int nDropTop;
	int nDropBottom = m_rectGraph.bottom;
	int nKyotsuKoteiIndex;
	CPoint pointLastJido = 0;
	int nTotalSeisanDaisu = g_pDataManager->GetTotalSeisanDaisu( nSublineId );

	// Ot̃ubNɂ郋[v
	fBottom = nTop;
	int nSize = aGraphBlock.GetSize();
	for (i = 0; i < nSize; i++) {
		SGraphBlock &cGraphBlock = aGraphBlock[i];
		CString &sName = pDoc->m_nGraphKind == GRAPH_KOTEI ? cGraphBlock.sKoteiName : cGraphBlock.sYosoSagyogunName;

// Modify ... ( CHANGE )
		if (pWnd->m_nGraphKishu == -1 || cGraphBlock.nKishuId == pWnd->m_nGraphKishu) {
//		if (pDoc->m_nGraphKishu == -1 || cGraphBlock.nKishuId == pDoc->m_nGraphKishu) {
// By Y.Itabashi (xxxxx) 2007.02.26
			pLastGraphBlock = &cGraphBlock;

			// Lbg̃TuC؂
			if (cGraphBlock.bKitting) {
				if (nKittingSublineId != cGraphBlock.nSublineId) {
					if (nKittingSublineId != -1) {
						SZahyoKittingSubline *pKittingSubline = m_aZahyoKittingSubline.AddElement();
						pKittingSubline->pointLine.x = nLeft;
						pKittingSubline->pointLine.y = (int)fBottom;
						pKittingSubline->sSiblineName1 = g_pDataManager->GetSublineData(cGraphBlock.nSublineId)->sSublineName;

						if (i == 0) {
							pKittingSubline = m_aZahyoKittingSubline.AddElement();
							SZahyoDrag &cZahyoDrag = m_aZahyoDrag[m_aZahyoDrag.GetSize() - 1];
							pKittingSubline->pointLine.x = cZahyoDrag.rect.left;
							pKittingSubline->pointLine.y = cZahyoDrag.rect.top;
						}

						pKittingSubline->sSiblineName2 = g_pDataManager->GetSublineData(nKittingSublineId)->sSublineName;
					}
					nKittingSublineId = cGraphBlock.nSublineId;
				}
			}

			// Ot̎lpë̍WvZ
// Modify ... ( CHANGE )
			if (pWnd->m_nGraphKishu == -1) {
//			if (pDoc->m_nGraphKishu == -1) {
// By Y.Itabashi (xxxxx) 2007.02.26
				SKishu *pKishu = g_pDataManager->GetKishuData(cGraphBlock.nKishuId);
				fRatio = (double)pKishu->nSeisanDaisu / nTotalSeisanDaisu;
			} else
				fRatio = 1;

			fTop = fBottom - cGraphBlock.fTime * m_fScaleFactor * fRatio;
			rect.SetRect(nLeft, (int)fTop, nLeft + m_nBarWidth, (int)fBottom);
			fBottom = fTop;
			sText.Format("%s\n%g", sName, cGraphBlock.fTime);
			AddZahyoGraph(rect, sText, COORDINATE_KIND_SAGYO, cGraphBlock.nKishuId);
			AddZahyoDrag(rect, &cGraphBlock, nSagyoshaId);
			nDropTop = (rect.bottom + rect.top) / 2;
			AddZahyoDrop(CRect(nLeft, nDropTop, rect.right, nDropBottom), &cGraphBlock, nSagyoshaId, CPoint(nLeft, rect.bottom), FALSE);
			nDropBottom = nDropTop;

			// Lbgɂ镜g
			if (cGraphBlock.bKittingCancel)
				m_aKittingCancel.Add(rect);

			// ʍH̘g̍W
			if (cGraphBlock.bKyotsuKotei) {
				if (nGroupNo != cGraphBlock.nGroupNo) {
					nKyotsuKoteiIndex = AddKyotsuKoteiFrame(rect);
					nGroupNo = cGraphBlock.nGroupNo;
				} else
					m_aZahyoKyotsuKoteiFrame[nKyotsuKoteiIndex].rect.UnionRect(m_aZahyoKyotsuKoteiFrame[nKyotsuKoteiIndex].rect, rect);
			}

			// H̎Op̍WvZ
			if (cGraphBlock.sJido == g_pConst->m_sJido) {
				sText = sName;
				if (cGraphBlock.bKyotsuKotei) {
// Modify ... ( CHANGE )
					CString str = g_pSystem->m_cMenuDisp.GetMenu( Menu_ManualWindowText[7].MenuNo, Menu_ManualWindowText[7].ItemNo );
					sText += str;
//					sText += "iʁj";
// By Y.Itabashi (xxxxx) 2007.01.26
					bJidoKyotsuKotei = TRUE;
				}
				if (aJidoKoteiName.Find(sText) == -1) {
					if (aJidoKoteiName.GetSize() == 0) {
						rectJido.SetRect(nLeft + m_nBarWidth + 1, (int)(fBottom - JIDO_SIZE), nLeft + m_nBarWidth + JIDO_SIZE + 2, (int)(fBottom + JIDO_SIZE));

						if (pointLastJido == rectJido.TopLeft())
							rectJido.OffsetRect(JIDO_SIZE + 1, 0);

						pointLastJido = rectJido.TopLeft();
					}

					aJidoKoteiName.InsertAt(0, sText);
				}
			}
			if (cGraphBlock.sJido != g_pConst->m_sJido || cGraphBlock.fTime != 0) {
				if (aJidoKoteiName.GetSize() != 0)
					AddZahyoGraph(rectJido, aJidoKoteiName.Join("\n\n"), bJidoKyotsuKotei ? COORDINATE_KIND_JIDO_KYOTSU : COORDINATE_KIND_JIDO);

				bJidoKyotsuKotei = FALSE;
				aJidoKoteiName.RemoveAll();
			}

			// H̎Op̍WvZ
			if (cGraphBlock.sJido == g_pConst->m_sHanJido) {
				sText = sName;
				if (cGraphBlock.bKyotsuKotei) {
// Modify ... ( CHANGE )
					CString str = g_pSystem->m_cMenuDisp.GetMenu( Menu_ManualWindowText[7].MenuNo, Menu_ManualWindowText[7].ItemNo );
					sText += str;
//					sText += "iʁj";
// By Y.Itabashi (xxxxx) 2007.01.26
					bHanJidoKyotsuKotei = TRUE;
				}
				if (aHanJidoKoteiName.Find(sText) == -1) {
					if (aHanJidoKoteiName.GetSize() == 0) {
						rectHanJido.SetRect(nLeft + m_nBarWidth + 1, (int)(fBottom - JIDO_SIZE), nLeft + m_nBarWidth + JIDO_SIZE + 2, (int)(fBottom + JIDO_SIZE));

						if (pointLastJido == rectHanJido.TopLeft())
							rectHanJido.OffsetRect(JIDO_SIZE + 1, 0);

						pointLastJido = rectHanJido.TopLeft();
					}

					aHanJidoKoteiName.InsertAt(0, sText);
				}
			}
			if (cGraphBlock.sJido != g_pConst->m_sHanJido || cGraphBlock.fTime != 0) {
				if (aHanJidoKoteiName.GetSize() != 0)
					AddZahyoGraph(rectHanJido, aHanJidoKoteiName.Join("\n\n"), bHanJidoKyotsuKotei ? COORDINATE_KIND_HANJIDO_KYOTSU : COORDINATE_KIND_HANJIDO);

				bHanJidoKyotsuKotei = FALSE;
				aHanJidoKoteiName.RemoveAll();
			}
		}
	}

	if (aJidoKoteiName.GetSize() != 0)
		AddZahyoGraph(rectJido, aJidoKoteiName.Join("\n\n"), bJidoKyotsuKotei ? COORDINATE_KIND_JIDO_KYOTSU : COORDINATE_KIND_JIDO);

	if (aHanJidoKoteiName.GetSize() != 0)
		AddZahyoGraph(rectHanJido, aHanJidoKoteiName.Join("\n\n"), bHanJidoKyotsuKotei ? COORDINATE_KIND_HANJIDO_KYOTSU : COORDINATE_KIND_HANJIDO);

	BOOL bLastBlock = TRUE;
	SGraphBlock *pLastGraphBlock2 = pLastGraphBlock;
	if (pLastGraphBlock2 == NULL) {
		pLastGraphBlock2 = pDoc->GetFirstGraphBlock(nSublineId);
		bLastBlock = FALSE;
	}
	AddZahyoDrop(CRect(nLeft, (int)fBottom - 50, nLeft + m_nBarWidth, nDropBottom), pLastGraphBlock2, nSagyoshaId, CPoint(nLeft, (int)fBottom), bLastBlock);
}

//*****************************************************************************************************
//  1. ֐
//		CManualEditView1::SetViewSize
//----------------------------------------------------------------------------------------------------
//  2. @\
//		Ot̑傫ɍ킹ăr[TCYݒ
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//----------------------------------------------------------------------------------------------------
//  5. Tv
//		EBhETCYɍ킹ăr[̃TCYvZB
//----------------------------------------------------------------------------------------------------
//  6. l
//----------------------------------------------------------------------------------------------------
//  7. 
//		2006.09.01 S.Aizawa(xxx) VK쐬
//*****************************************************************************************************
void CManualEditView1::SetViewSize()
{
// Modify ... ( CHANGE )
	CManualEditChildWnd *pWnd = (CManualEditChildWnd *)GetParentFrame();
//	CManualEditDocument *pDoc = GetDocument();
// By Y.Itabashi (xxxxx) 2007.02.26

	// r[̃TCYvZ
	int nSagyoshaNum = GetTotalSagyoshaNum();
	GetClientRect(m_rectView);
	m_rectView.right = m_nLeftMargin + m_nLeftSpacing + nSagyoshaNum * (m_nBarWidth + m_nBarSpacing) + m_nRightMargin;
	int nKittingSagyoshaNum = GetKittingSagyoshaNum();
	if (nKittingSagyoshaNum != 0)
		m_rectView.right += m_nBarSpacing + nKittingSagyoshaNum * (m_nBarWidth + m_nBarSpacing);

	// OẗvZ
	m_rectGraph = m_rectView;
	m_rectGraph.DeflateRect(m_nLeftMargin, m_nTopMargin, m_nRightMargin, m_nBottomMargin);

	SetScaleFactor(FALSE, 0);

	// ԍo[ɍ킹ăr[̈g
// Modify ... ( CHANGE )
	int nOverHeight = GetScaleHeight(GetMaxTime(pWnd->m_nGraphKishu)) - m_rectGraph.Height();
//	int nOverHeight = GetScaleHeight(GetMaxTime(pDoc->m_nGraphKishu)) - m_rectGraph.Height();
// By Y.Itabashi (xxxxx) 2007.02.26
	if (nOverHeight > 0) {
		m_rectView.bottom += nOverHeight;
		m_rectGraph.bottom += nOverHeight;
	}

// Modify ... ( CHANGE )
	SCROLLINFO scrollInfo;
	CScrollBar *pBar;

	// XN[o[̐ݒ
	pBar = GetScrollBarCtrl( SB_HORZ );
	memset( &scrollInfo, '\0', sizeof(SCROLLINFO) );
	scrollInfo.fMask = SIF_RANGE;
	scrollInfo.nMin = 0;
	scrollInfo.nMax = m_rectView.Width();
	pBar->SetScrollInfo( &scrollInfo, TRUE );

	// XN[o[̐ݒ
	pBar = GetScrollBarCtrl( SB_VERT );
	memset( &scrollInfo, '\0', sizeof(SCROLLINFO) );
	scrollInfo.fMask = SIF_RANGE;
	scrollInfo.nMin = 0;
	scrollInfo.nMax = m_rectView.Height();
	pBar->SetScrollInfo( &scrollInfo, TRUE );
	scrollInfo.fMask = SIF_PAGE;
	if (nOverHeight > 0)
		scrollInfo.nPage = m_rectView.Height() / 10;
	else
		scrollInfo.nPage = m_rectView.Height();
	pBar->SetScrollInfo( &scrollInfo, TRUE );
	if( nOverHeight<= 0 )
		pBar->EnableWindow( FALSE );

	SetScrollSizes(MM_TEXT, CSize(m_rectView.Width(), m_rectView.Height()));
// By Y.Itabashi (xxxxx) 2007.03.04
}

void CManualEditView1::DrawNewMoveFrame(CDC *pDC)
{
	if (!m_rectNewMove.IsRectNull()) {
		CPen *pPenOrg = pDC->SelectObject(&m_penNewMove);
		CBrush *pBrushOrg = (CBrush *)pDC->SelectStockObject(NULL_BRUSH);

		CRect rect(m_rectNewMove.left, m_rectNewMove.top, m_rectNewMove.right + 1, m_rectNewMove.bottom + 1);
		pDC->Rectangle(rect);

		pDC->SelectObject(pPenOrg);
		pDC->SelectObject(pBrushOrg);
	}
}

//*****************************************************************************************************
//  1. ֐
//		CManualEditView1::DrawHorizontalAxisText
//----------------------------------------------------------------------------------------------------
//  2. @\
//		eLXg`
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		CDC		*pDC			[I] foCXReLXg
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//----------------------------------------------------------------------------------------------------
//  5. Tv
//		̃eLXgiƎҖj`悷B
//----------------------------------------------------------------------------------------------------
//  6. l
//----------------------------------------------------------------------------------------------------
//  7. 
//		2006.09.01 S.Aizawa(xxx) VK쐬
//*****************************************************************************************************
void CManualEditView1::DrawHorizontalAxisText(CDC *pDC)
{
	CManualEditDocument *pDoc = GetDocument();

	int nLeft = m_rectGraph.left + m_nLeftSpacing;
	int nGraphSublineNum = pDoc->m_aGraphSubline.GetSize();
	for (int nSublineIndex = 0; nSublineIndex < nGraphSublineNum; nSublineIndex++) {
		SGraphSubline &cGraphSubline = pDoc->m_aGraphSubline[nSublineIndex];

		if (cGraphSubline.nSublineId == -1)
			nLeft += m_nBarSpacing;

		DrawHorizontalAxisTextSub(pDC, pDoc->m_aGraphSubline[nSublineIndex], nLeft);
	}
}

//*****************************************************************************************************
//  1. ֐
//		CManualEditView1::DrawHorizontalAxisTextSub
//----------------------------------------------------------------------------------------------------
//  2. @\
//		eLXg`
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		CDC					*pDC				[I] foCXReLXg
//		CGraphSagyoshaArray	&aGraphSagyosha		[I] OtƎҔz
//		int					&nLeft				[I/O] XW
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//----------------------------------------------------------------------------------------------------
//  5. Tv
//		̃eLXgiƎҖj`悷B
//----------------------------------------------------------------------------------------------------
//  6. l
//----------------------------------------------------------------------------------------------------
//  7. 
//		2006.09.01 S.Aizawa(xxx) VK쐬
//*****************************************************************************************************
void CManualEditView1::DrawHorizontalAxisTextSub(CDC *pDC, SGraphSubline &cGraphSubline, int &nLeft)
{
	CManualEditDocument *pDoc = GetDocument();

	CFont *pFontOrg = pDC->SelectObject(&m_fontH);

	// Ǝ҂ɂ郋[v
	CRect rect;
	int nSagyoshaNum = cGraphSubline.aGraphSagyosha.GetSize();
	for (int i = 0; i < nSagyoshaNum; i++) {
		SGraphSagyosha &cGraphSagyosha = cGraphSubline.aGraphSagyosha[i];
		CSize size = pDC->GetTextExtent(cGraphSagyosha.sSagyoshaName);
		int x = nLeft + (m_nBarWidth - size.cx) / 2;
		rect.SetRect(x, m_rectGraph.bottom + 8, x + size.cx, m_rectView.bottom);
		if (pDC->RectVisible(rect)) {
//			double fTime = (pDoc->m_nGraphKishu == -1) ? cGraphSagyosha.fTime : cGraphSagyosha.aKishu[pDoc->m_nGraphKishu].fTime;

			// ƎҖ\
			int color;
			if (pDoc->m_cSelectSagyosha.bSelect && pDoc->m_cSelectSagyosha.nSubnlineId == cGraphSubline.nSublineId && pDoc->m_cSelectSagyosha.nSagyoshaId == cGraphSagyosha.nSagyoshaId)
				color = pDC->SetTextColor(g_pSystem->m_cIniUser.m_rgbSelectWorkerColor);
			else
				color = pDC->SetTextColor(RGB(0, 0, 0));
			pDC->TextOut(rect.left, rect.top, cGraphSagyosha.sSagyoshaName);
			pDC->SetTextColor(color);
		}

		nLeft += m_nBarWidth + m_nBarSpacing;
	}

	pDC->SelectObject(pFontOrg);
}

//*****************************************************************************************************
//  1. ֐
//		CManualEditView1::DrawTotalTime
//----------------------------------------------------------------------------------------------------
//  2. @\
//		vԕ`
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		CDC		*pDC			[I] foCXReLXg
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//----------------------------------------------------------------------------------------------------
//  5. Tv
//		Ot̃o[̏ɍvԂ`悷B
//----------------------------------------------------------------------------------------------------
//  6. l
//----------------------------------------------------------------------------------------------------
//  7. 
//		2006.09.01 S.Aizawa(xxx) VK쐬
//*****************************************************************************************************
void CManualEditView1::DrawTotalTime(CDC *pDC)
{
	CManualEditDocument *pDoc = GetDocument();

	int nLeft = m_rectGraph.left + m_nLeftSpacing;
	int nGraphSublineNum = pDoc->m_aGraphSubline.GetSize();
	for (int nSublineIndex = 0; nSublineIndex < nGraphSublineNum; nSublineIndex++) {
		SGraphSubline &cGraphSubline = pDoc->m_aGraphSubline[nSublineIndex];

		if (cGraphSubline.nSublineId == -1)
			nLeft += m_nBarSpacing;

		DrawTotalTimeSub(pDC, pDoc->m_aGraphSubline[nSublineIndex], nLeft);
	}
}

//*****************************************************************************************************
//  1. ֐
//		CManualEditView1::DrawTotalTimeSub
//----------------------------------------------------------------------------------------------------
//  2. @\
//		vԕ`
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		CDC					*pDC				[I] foCXReLXg
//		CGraphSagyoshaArray	&aGraphSagyosha		[I] OtƎҔz
//		int					&nLeft				[I/O] XW
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//----------------------------------------------------------------------------------------------------
//  5. Tv
//		Ot̃o[̏ɍvԂ`悷B
//----------------------------------------------------------------------------------------------------
//  6. l
//----------------------------------------------------------------------------------------------------
//  7. 
//		2006.09.01 S.Aizawa(xxx) VK쐬
//*****************************************************************************************************
void CManualEditView1::DrawTotalTimeSub(CDC *pDC, SGraphSubline &cGraphSubline, int &nLeft)
{
// Modify ... ( CHANGE )
	CManualEditChildWnd *pWnd = (CManualEditChildWnd *)GetParentFrame();
//	CManualEditDocument *pDoc = GetDocument();
// By Y.Itabashi (xxxxx) 2007.02.26

	CFont *pFontOrg = pDC->SelectObject(&m_fontTime);

	CString sTime;
	CRect rectText;

	// Ƃɂ郋[v
	int nSagyoshaNum = cGraphSubline.aGraphSagyosha.GetSize();
	for (int i = 0; i < nSagyoshaNum; i++) {
		SGraphSagyosha &cGraphSagyosha = cGraphSubline.aGraphSagyosha[i];
// Modify ... ( CHANGE )
		double fTime = (pWnd->m_nGraphKishu == -1) ? cGraphSagyosha.fTime : cGraphSagyosha.aKishu[pWnd->m_nGraphKishu].fTime;
//		double fTime = (pDoc->m_nGraphKishu == -1) ? cGraphSagyosha.fTime : cGraphSagyosha.aKishu[pDoc->m_nGraphKishu].fTime;
// By Y.Itabashi (xxxxx) 2007.02.26
		DrawTime(pDC, cGraphSubline, nLeft, fTime);

		nLeft += m_nBarWidth + m_nBarSpacing;
	}

	pDC->SelectObject(pFontOrg);
}

// Lbgɂ镜g`
void CManualEditView1::DrawKittingCancelFrame(CDC *pDC)
{
// Modify ... ( ADD )
	// ŐV̈ړ̕\
	if( m_rectNewMove.IsRectNull() ){
		CIntArrayEx aCheckArea;
		aCheckArea.RemoveAll();

		while( 1 ){

			CRect newRect;
			newRect.SetRectEmpty();

			for( int i = 0; i < m_aKittingCancel.GetSize(); i++ ){
				if( aCheckArea.Find( i ) != -1 )
					continue;

				if( newRect.IsRectNull() ){
					newRect = m_aKittingCancel[i];
					aCheckArea.Add( i );
					continue;
				}

				if( newRect.left != m_aKittingCancel[i].left )
					continue;

				if( newRect.top == m_aKittingCancel[i].bottom ||
					newRect.bottom == m_aKittingCancel[i].top )
					newRect.UnionRect( newRect, m_aKittingCancel[i] );
				else
					continue;

				aCheckArea.Add( i );
			}

			if( !newRect.IsRectNull() ){
				CPen *pPenOrg = pDC->SelectObject(&m_penNewMove);
				CBrush *pBrushOrg = (CBrush *)pDC->SelectStockObject(NULL_BRUSH);

				CRect rect(newRect.left, newRect.top, newRect.right + 1, newRect.bottom + 1);
				pDC->Rectangle(rect);

				pDC->SelectObject(pPenOrg);
				pDC->SelectObject(pBrushOrg);
			}else
				break;
		}
		aCheckArea.RemoveAll();
	}
// By Y.Itabashi (xxxxx) 2007.03.06

	CPen *pPenOrg = pDC->SelectObject(&m_penKittingCancel);

	int nSize = m_aKittingCancel.GetSize();
	for (int i = 0; i < nSize; i++) {
		CRect rect = m_aKittingCancel[i];

		pDC->MoveTo(rect.left, rect.top);
		pDC->LineTo(rect.right, rect.top);
		pDC->MoveTo(rect.left, rect.top - 1);
		pDC->LineTo(rect.right, rect.top - 1);

		pDC->MoveTo(rect.right, rect.top);
		pDC->LineTo(rect.right, rect.bottom);
		pDC->MoveTo(rect.right - 1, rect.top);
		pDC->LineTo(rect.right - 1, rect.bottom);

		pDC->MoveTo(rect.left, rect.bottom);
		pDC->LineTo(rect.right, rect.bottom);
		pDC->MoveTo(rect.left, rect.bottom - 1);
		pDC->LineTo(rect.right, rect.bottom - 1);

		pDC->MoveTo(rect.left, rect.top);
		pDC->LineTo(rect.left, rect.bottom);
		pDC->MoveTo(rect.left - 1, rect.top);
		pDC->LineTo(rect.left - 1, rect.bottom);
	}

	pDC->SelectObject(pPenOrg);
}

// QƍHg`
void CManualEditView1::DrawReferenceFrame(CDC *pDC)
{
	CManualEditDocument *pDoc = GetDocument();
	int nGraphKishu = ((CManualEditChildWnd *)GetParentFrame())->m_nGraphKishu;
	int nReferenceBox = pDoc->m_aRefYosoSagyogun.GetSize();
	if (nReferenceBox == 0)
		return;

	int i, j;
	CArray <CRect, CRect&> aBlinkRect;

	for (i = 0; i < nReferenceBox; i++) {

		if( nGraphKishu != pDoc->m_aRefYosoSagyogun[i].nKishuId )
			continue;

		int nIndex = ( nGraphKishu == -1 ) ? pDoc->m_aRefYosoSagyogun[i].nIndex : pDoc->m_aRefYosoSagyogun[i].nIndexKishu;
		CRect rectRefBox = m_aZahyoDrag[nIndex].rect;

		int nBlinkRect = aBlinkRect.GetSize();
		for (j = 0; j < nBlinkRect; j++) {
			CRect &rectBlink = aBlinkRect[j];

			if (rectRefBox.left == rectBlink.left) {
				if (rectRefBox.bottom == rectBlink.top) {
					rectBlink.top = rectRefBox.top;
					break;
				}

				if (rectRefBox.top == rectBlink.bottom) {
					 rectBlink.bottom = rectRefBox.bottom;
					break;
				}
			}
		}

		if (j == nBlinkRect)
			aBlinkRect.Add(rectRefBox);
	}

	CPen *pPenOrg = pDC->SelectObject(&m_penReference);
	CBrush *pBrushOrg = (CBrush *)pDC->SelectStockObject(NULL_BRUSH);

	for (j = 0; j < aBlinkRect.GetSize(); j++) {
		CRect rect(aBlinkRect[j]);
		rect.right++;
		rect.bottom++;
		pDC->Rectangle(rect);
	}

	pDC->SelectObject(pPenOrg);
	pDC->SelectObject(pBrushOrg);
}

//*****************************************************************************************************
//  1. ֐
//		CManualEditView1::OnRButtonDown
//----------------------------------------------------------------------------------------------------
//  2. @\
//		ENbN
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		UINT		nFlags			[I] zL[̏
//		CPoint		point			[I] }EXJ[\̍W
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//----------------------------------------------------------------------------------------------------
//  5. Tv
//		ENbNj[\B
//----------------------------------------------------------------------------------------------------
//  6. l
//----------------------------------------------------------------------------------------------------
//  7. 
//		2006.09.01 S.Aizawa(xxx) VK쐬
//*****************************************************************************************************
void CManualEditView1::OnRButtonDown(UINT nFlags, CPoint point)
{
// Modify ... ( ADD )
	CManualEditChildWnd *pWnd = (CManualEditChildWnd *)GetParentFrame();
// By Y.Itabashi (xxxxx) 2007.02.26
	CManualEditDocument *pDoc = GetDocument();

	// NbNꂽOt̍W߂
	CRect rect;
	m_pRightClickZahyo = CheckZahyoDrag(point, rect);

	// \[X烁j[[h
	CMenu cMenu;
	cMenu.LoadMenu(IDR_MANUAL_POPUPMENU);
	CMenu* pPopup = cMenu.GetSubMenu(0);

// Modify ... ( ADD )
	g_pSystem->m_cMenuDisp.SetMenuText( (CWnd *)pPopup, Menu_ManualWindowPopup );
// By Y.Itabashi (xxxxx) 2007.01.26

	if (m_pRightClickZahyo == NULL) {
// Modify ... ( CHANGE )
		if (pWnd->m_nGraphKishu == -1) {
//		if (pDoc->m_nGraphKishu == -1) {
// By Y.Itabashi (xxxxx) 2007.02.26
			// Ot̃o[̏łȂdϕ\ł̈ړA폜͕s
// Modify ... ( CHANGE )
//			pPopup->EnableMenuItem(IDM_MANUAL_MOVE, MF_GRAYED);
// By Y.Itabashi (xxxxx)
			pPopup->EnableMenuItem(IDM_MANUAL_BUNKATSU, MF_GRAYED);
		}
	}

	// dϕ\͕ҏWs
// Modify ... ( CHANGE )
	// UP4o׃W[p
// Modify ... ( CHANGE )
	if (pWnd->m_nGraphKishu == -1)
//	if (pDoc->m_nGraphKishu == -1)
// By Y.Itabashi (xxxxx) 2007.02.26
		pPopup->EnableMenuItem(IDM_MANUAL_EDIT, MF_GRAYED);
// By Y.Itabashi (xxxxx) 2007.02.22
// Modify ... ( ADD )
// Modify ... ( CHANGE )
	if (pWnd->m_nGraphKishu == -1)
//	if (pDoc->m_nGraphKishu == -1)
// By Y.Itabashi (xxxxx) 2007.02.26
		pPopup->EnableMenuItem(IDM_MANUAL_PASTE, MF_GRAYED);
// By Y.Itabashi (xxxxx)

	// IĂRs[͕s
// Modify ... ( CHANGE )
	// UP4o׃W[p
//	if (pDoc->m_aSelectedBox.GetSize() > 1 || pDoc->m_aSelectedBox.GetSize() == 0 || pDoc->m_bSelectKitting)
	if (pDoc->m_aSelectYosoSagyogun.GetSize() > 1 || pDoc->m_aSelectYosoSagyogun.GetSize() == 0 || pDoc->m_bSelectKitting)
		pPopup->EnableMenuItem(IDM_MANUAL_COPY, MF_GRAYED);
// By Y.Itabashi (xxxxx) 2007.02.27

// Modify ... ( ADD )
	// UP4o׃W[p
//	pPopup->EnableMenuItem(IDM_MANUAL_EDIT, MF_GRAYED);
//	pPopup->EnableMenuItem(IDM_MANUAL_MOVE, MF_GRAYED);
//	pPopup->EnableMenuItem(IDM_MANUAL_COPY, MF_GRAYED);
//	pPopup->EnableMenuItem(IDM_MANUAL_PASTE, MF_GRAYED);
// By Y.Itabashi (xxxxx) 2007.02.22

	// NbNꂽʒuɃ|bvAbvj[\
	::GetCursorPos(&point);
	pPopup->TrackPopupMenu(TPM_LEFTALIGN | TPM_RIGHTBUTTON, point.x, point.y, this);

	CManualEditView::OnRButtonDown(nFlags, point);
}

//*****************************************************************************************************
//  1. ֐
//		CManualEditView1::OnManualMove
//----------------------------------------------------------------------------------------------------
//  2. @\
//		HEvfƌQ̈ړ
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//----------------------------------------------------------------------------------------------------
//  5. Tv
//		HEvfƌQ̈ړ_CAOJB
//----------------------------------------------------------------------------------------------------
//  6. l
//----------------------------------------------------------------------------------------------------
//  7. 
//		2006.09.01 S.Aizawa(xxx) VK쐬
//*****************************************************************************************************
void CManualEditView1::OnManualMove()
{
	// CKt@CJĂG[
	if (g_pDataManager->m_bOpenLineKiseiMatrix) {
		g_pSystem->DispMessage("E006002");
		return;
	}

	// ^Kt@CJĂG[
	if (g_pDataManager->m_bOpenKatashikiKiseiMatrix) {
		g_pSystem->DispMessage("E006102");
		return;
	}

	CManualMoveDlg dlg(this);

	CManualEditDocument *pDoc = GetDocument();
	if (m_pRightClickZahyo != NULL) {
		// Ot̃o[Ȃ炻̃f[^_CAOɓn
		dlg.m_nKishuId = m_pRightClickZahyo->pGraphBlock->nKishuId;
		dlg.m_sSagyosha = g_pDataManager->GetSagyoshaName(m_pRightClickZahyo->pGraphBlock->nSublineId, m_pRightClickZahyo->nSagyoshaId);
	} else {
		// Ot̃o[łȂȂ@_CAOɓn
// Modify ... ( CHANGE )
		dlg.m_nKishuId = ((CManualEditChildWnd *)GetParentFrame())->m_nGraphKishu;
		dlg.m_nGraphKishu = ((CManualEditChildWnd *)GetParentFrame())->m_nGraphKishu;
//		dlg.m_nKishuId = pDoc->m_nGraphKishu;
// By Y.Itabashi (xxxxx) 2007.02.26
	}
	dlg.m_nMode = pDoc->m_nGraphKind;
	dlg.m_pDoc = pDoc;

	// HEvfƌQ̈ړ_CAO\
	if (dlg.DoModal() == IDOK) {
		// OK{^ȂOtXV
		GetDocument()->UpdateGraph(FALSE);

		// ݂̃f[^Undoobt@ɕۑ
		g_pDataManager->SaveUndoBuf();
	} else {
		// Cancel{^ȂOtɖ߂
		GetDocument()->UpdateGraph(FALSE);
	}
}

//*****************************************************************************************************
//  1. ֐
//		CManualEditView1::OnManualBunkatsu
//----------------------------------------------------------------------------------------------------
//  2. @\
//		HEvfƌQ̕폜
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//----------------------------------------------------------------------------------------------------
//  5. Tv
//		HEvfƌQ̕폜_CAOJB
//----------------------------------------------------------------------------------------------------
//  6. l
//----------------------------------------------------------------------------------------------------
//  7. 
//		2006.09.01 S.Aizawa(xxx) VK쐬
//*****************************************************************************************************
void CManualEditView1::OnManualBunkatsu()
{
	CManualBunkatsuDlg dlg(this);

	if (m_pRightClickZahyo != NULL) {
		// Ot̃o[Ȃ炻̃f[^_CAOɓn
		dlg.m_nKishuId = m_pRightClickZahyo->pGraphBlock->nKishuId;
/*
		dlg.m_nSagyoshaId = m_pRightClickZahyo->nSagyoshaId;
		dlg.m_sKoteiName = m_pRightClickZahyo->pGraphBlock->sKoteiName;
		dlg.m_sYosoSagyogunName = m_pRightClickZahyo->pGraphBlock->sYosoSagyogunName;
*/
	} else {
		// Ot̃o[łȂȂ@_CAOɓn
// Modify ... ( CHANGE )
		CManualEditChildWnd *pWnd = (CManualEditChildWnd *)GetParentFrame();
		dlg.m_nKishuId = pWnd->m_nGraphKishu;
//		CManualEditDocument *pDoc = GetDocument();
//		dlg.m_nKishuId = pDoc->m_nGraphKishu;
// By Y.Itabashi (xxxxx) 2007.02.26
	}
	dlg.m_pDoc = GetDocument();

	// HEvfƌQ̕폜_CAO\
	if (dlg.DoModal() == IDOK) {
		// OK{^ȂOtXV
		GetDocument()->UpdateGraph(TRUE);

		// ݂̃f[^Undoobt@ɕۑ
		g_pDataManager->SaveUndoBuf();
	} else {
		// Cancel{^ȂOtɖ߂
		GetDocument()->UpdateGraph(FALSE);
	}
}

//*****************************************************************************************************
//  1. ֐
//		CManualEditView1::OnManualEdit
//----------------------------------------------------------------------------------------------------
//  2. @\
//		HEvfƌQ̏C
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//----------------------------------------------------------------------------------------------------
//  5. Tv
//		HEvfƌQ̏C_CAOJB
//----------------------------------------------------------------------------------------------------
//  6. l
//----------------------------------------------------------------------------------------------------
//  7. 
//		2006.09.01 S.Aizawa(xxx) VK쐬
//*****************************************************************************************************
void CManualEditView1::OnManualEdit()
{
	CManualEditDocument *pDoc = GetDocument();
	CManualEditDlg dlg(this);

	if (m_pRightClickZahyo != NULL && !m_pRightClickZahyo->pGraphBlock->bKitting) {
		dlg.m_nKishuId = m_pRightClickZahyo->pGraphBlock->nKishuId;
		dlg.m_nSagyoshaId = m_pRightClickZahyo->nSagyoshaId;
	} else {
// Modify ... ( CHANGE )
		dlg.m_nKishuId = ((CManualEditChildWnd *)GetParentFrame())->m_nGraphKishu;
//		dlg.m_nKishuId = pDoc->m_nGraphKishu;
// By Y.Itabashi (xxxxx) 2007.02.26
	}
	dlg.m_pDoc = pDoc;

	if (dlg.DoModal() == IDOK) {
		// OK{^ȂOtXV
		GetDocument()->UpdateGraph(TRUE);

		// ݂̃f[^Undoobt@ɕۑ
		g_pDataManager->SaveUndoBuf();
	} else {
		// Cancel{^ȂOtɖ߂
		GetDocument()->UpdateGraph(FALSE);
	}
}

//*****************************************************************************************************
//  1. ֐
//		CManualEditView1::OnLButtonDown
//----------------------------------------------------------------------------------------------------
//  2. @\
//		}EX{^_E
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		UINT		nFlags			[I] zL[̏
//		CPoint		point			[I] }EXJ[\̍W
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//----------------------------------------------------------------------------------------------------
//  5. Tv
//		hbOJñ}EXJ[\̈ʒuۑB
//----------------------------------------------------------------------------------------------------
//  6. l
//----------------------------------------------------------------------------------------------------
//  7. 
//		2006.09.01 S.Aizawa(xxx) VK쐬
//*****************************************************************************************************
void CManualEditView1::OnLButtonDown(UINT nFlags, CPoint point)
{

// Modify ... ( ADD )
	// OɍƂIʂƓʂłȂ΁AINA
	if( GetParentFrame() != GetDocument()->m_pSelectWnd )
		ResetSelectedBox();

	GetDocument()->m_pSelectWnd = GetParentFrame();
// By Y.Itabashi (xxxxx) 2007.02.27

	// NbNꂽW`FbN
	SZahyoDrag *pZahyoDrag = CheckZahyoDrag(point, m_rectDrag);
	if (pZahyoDrag != NULL) {
// Modify ... ( CHANGE )
		if (!pZahyoDrag->pGraphBlock->bKitting)
			ClickSublineArea(point, pZahyoDrag, nFlags);
//			ClickSublineArea(point, pZahyoDrag);
		else
			ClickKittingArea(point, pZahyoDrag, nFlags);
//			ClickKittingArea(point, pZahyoDrag);
// By Y.Itabashi (xxxxx) 2007.02.20
	} else {
		// VtgL[ăLbgGAȂIȂ
		SZahyoSubline *pZahyoSubline = GetZahyoSubline(point);
// Modify ... ( CHANGE )
		if ( pZahyoSubline == NULL || pZahyoSubline->nSublineId != -1 ||
			 ( nFlags != 0x0005 && pZahyoSubline->nSublineId == -1 ) )
//		if (!(GetKeyState(VK_SHIFT) & 0x8000) || pZahyoSubline == NULL || pZahyoSubline->nSublineId != -1)
// By Y.Itabashi (xxxxx) 2007.03.06
			ResetSelectedBox();

		SetCapture();
		m_rectSelect.SetRect(point, point);
		DrawFocusRect(m_rectSelect);
		m_nMouseMoveMode = MOUSE_SELECT;
	}

	SelectSagyosha(point);

	CManualEditView::OnLButtonDown(nFlags, point);
}

// Modify ... ( CHANGE )
void CManualEditView1::ClickSublineArea(CPoint point, SZahyoDrag *pZahyoDrag, UINT nFlags)
//void CManualEditView1::ClickSublineArea(CPoint point, SZahyoDrag *pZahyoDrag)
// By Y.Itabashi (xxxxx) 2007.02.21
{
	CManualEditDocument *pDoc = GetDocument();
	int i;

// Modify ... ( CHANGE )
	int nGraphKishu = ((CManualEditChildWnd *)GetParentFrame())->m_nGraphKishu;
	int nSelectedBox = pDoc->m_aSelectYosoSagyogun.GetSize();
//	int nSelectedBox = pDoc->m_aSelectedBox.GetSize();
// By Y.Itabashi (xxxxx) 2007.02.27

	// VtgL[`FbN
// Modify ... ( CHANGE )
	if (nFlags == 0x0005) {
//	if (GetKeyState(VK_SHIFT) & 0x8000) {
// By Y.Itabashi (xxxxx) 2007.02.21
		// VtgL[Ăꍇ̏
		if (nSelectedBox == 0) {
			// ЂƂIĂȂꍇ̓NbNꏊI
			AddSelect(pZahyoDrag->nIndex);
		} else {
			// ɑIĂꍇ́ANbNꏊƂ̊ԂSđI
// Modify ... ( CHANGE )
			int nIndex = ( nGraphKishu == -1 ) ? pDoc->m_aSelectYosoSagyogun[0].nIndex : pDoc->m_aSelectYosoSagyogun[0].nIndexKishu;
			SZahyoDrag &cSelectedZahyoDrag = m_aZahyoDrag[nIndex];
			if (cSelectedZahyoDrag.rect.left == pZahyoDrag->rect.left) {
//			SZahyoDrag &cSelectedZahyoDrag = m_aZahyoDrag[pDoc->m_aSelectedBox[0]];
//			if (m_aZahyoDrag[pDoc->m_aSelectedBox[0]].rect.left == pZahyoDrag->rect.left) {
// By Y.Itabashi (xxxxx) 2007.02.27
				CRect rect = GetSelectRect();
				rect.UnionRect(rect, pZahyoDrag->rect);
	
				ResetSelectedBox();
				int nSize = m_aZahyoDrag.GetSize();
				for (i = 0; i < nSize; i++) {
					SZahyoDrag &cZahyoDrag = m_aZahyoDrag[i];
					if (rect.PtInRect(cZahyoDrag.rect.TopLeft()))
						AddSelect(cZahyoDrag.nIndex);
				}
			} else {
				ResetSelectedBox();
				AddSelect(pZahyoDrag->nIndex);
			}
		}
	} else {
		// VtgL[ĂȂꍇ̏
		if (nSelectedBox == 0) {
			// ЂƂIĂȂꍇ̓NbNꏊI
			AddSelect(pZahyoDrag->nIndex);
		} else if (nSelectedBox == 1) {
			// ЂƂIĂꍇ́AăNbNꏊI
// Modify ... ( CHANGE )
			int nIndex = ( nGraphKishu == -1 ) ? pDoc->m_aSelectYosoSagyogun[0].nIndex : pDoc->m_aSelectYosoSagyogun[0].nIndexKishu;
			SZahyoDrag &cSelectedZahyoDrag = m_aZahyoDrag[nIndex];
			if (pZahyoDrag->nIndex == cSelectedZahyoDrag.nIndex)
//			if (pZahyoDrag->nIndex == m_aZahyoDrag[pDoc->m_aSelectedBox[0]].nIndex)
// By Y.Itabashi (xxxxx) 2007.02.27
				m_nSelectRemoveIndex = pZahyoDrag->nIndex;
			else {
				ResetSelectedBox();
				AddSelect(pZahyoDrag->nIndex);
			}
		} else {
			// IĂꍇ́A㉺[ȂI
// Modify ... ( CHANGE )
			int m_nGraphKishu = ((CManualEditChildWnd *)GetParentFrame())->m_nGraphKishu;
			int nLastIndex = nSelectedBox-1;
// Modify ... ( CHANGE )
			for( i = nSelectedBox-1; i >= 0 && m_nGraphKishu != -1; i-- ){
//			for( i = nSelectedBox-1; i >= 0; i-- ){
				if( pDoc->m_aSelectYosoSagyogun[i].nKishuId == m_nGraphKishu ){
					nLastIndex = i;
					break;
				}
// By Y.Itabashi (xxxxx) 2007.03.06

			}
			for (i = 0; i < nSelectedBox; i++) {
// Modify ... ( CHANGE )
				if( pDoc->m_aSelectYosoSagyogun[i].nKishuId != m_nGraphKishu &&
					m_nGraphKishu != -1 )
//				if( pDoc->m_aSelectYosoSagyogun[i].nKishuId != m_nGraphKishu )
// By Y.Itabashi (xxxxx) 2007.03.05
					continue;

				int nIndex = ( nGraphKishu == -1 ) ? pDoc->m_aSelectYosoSagyogun[i].nIndex : pDoc->m_aSelectYosoSagyogun[i].nIndexKishu;
				if (m_aZahyoDrag[nIndex].nIndex == pZahyoDrag->nIndex)
//				if (m_aZahyoDrag[pDoc->m_aSelectedBox[i]].nIndex == pZahyoDrag->nIndex)
					break;
			}
			if (i == 0 || i == nLastIndex) {
//			if (i == 0 || i == nSelectedBox - 1) {
				int nIndex = ( nGraphKishu == -1 ) ? pDoc->m_aSelectYosoSagyogun[i].nIndex : pDoc->m_aSelectYosoSagyogun[i].nIndexKishu;
				m_nSelectRemoveIndex = m_aZahyoDrag[nIndex].nIndex;
//				m_nSelectRemoveIndex = m_aZahyoDrag[pDoc->m_aSelectedBox[i]].nIndex;
			} else if (i == nSelectedBox) {
				ResetSelectedBox();
				AddSelect(pZahyoDrag->nIndex);
			}
// By Y.Itabashi (xxxxx) 2007.02.27
		}

		m_pointDrag = point;
		m_nMouseMoveMode = MOUSE_DRAG;
// Modify ... ( ADD )
		pDoc->m_pDragWnd = GetParentFrame();
// By Y.Itabashi (xxxxx) 2007.02.27
	}

// Modify ... ( ADD )
	pDoc->AddSelectKoteiOtherWindow();
// By Y.Itabashi (xxxxx) 2007.02.27
}

// Modify ... ( CHANGE )
void CManualEditView1::ClickKittingArea(CPoint point, SZahyoDrag *pZahyoDrag, UINT nFlags)
//void CManualEditView1::ClickKittingArea(CPoint point, SZahyoDrag *pZahyoDrag)
// By Y.Itabashi (xxxxx) 2007.02.21
{
// Modify ... ( ADD )
	// UP4pW[
//	return;
// By Y.Itabashi (xxxxx) 2007.02.14

	CManualEditDocument *pDoc = GetDocument();
	int i;

// Modify ... ( CHANGE )
	int nGraphKishu = ((CManualEditChildWnd *)GetParentFrame())->m_nGraphKishu;
	int nSelectedBox = pDoc->m_aSelectYosoSagyogun.GetSize();
//	int nSelectedBox = pDoc->m_aSelectedBox.GetSize();
// By Y.Itabashi (xxxxx) 2007.02.27

	// VtgL[`FbN
// Modify ... ( CHANGE )
	if (nFlags == 0x0005) {
//	if (GetKeyState(VK_SHIFT) & 0x8000) {
// By Y.Itabashi (xxxxx) 2007.02.21
		// VtgL[Ăꍇ̏
		AddSelect(pZahyoDrag->nIndex);
	} else {
		// VtgL[ĂȂꍇ̏
		if (nSelectedBox == 0) {
			// ЂƂIĂȂꍇ̓NbNꏊI
			AddSelect(pZahyoDrag->nIndex);
		} else if (nSelectedBox == 1) {
			// ЂƂIĂꍇ́AăNbNꏊI
// Modify ... ( CHANGE )
			int nIndex = ( nGraphKishu == -1 ) ? pDoc->m_aSelectYosoSagyogun[0].nIndex : pDoc->m_aSelectYosoSagyogun[0].nIndexKishu;
			if (pZahyoDrag->nIndex == m_aZahyoDrag[nIndex].nIndex)
//			if (pZahyoDrag->nIndex == m_aZahyoDrag[pDoc->m_aSelectedBox[0]].nIndex)
// By Y.Itabashi (xxxxx) 2007.02.27
				m_nSelectRemoveIndex = pZahyoDrag->nIndex;
			else {
				ResetSelectedBox();
				AddSelect(pZahyoDrag->nIndex);
			}
		} else {
			// IĂꍇ̓NbNꏊ̑I
// Modify ... ( CHANGE )
			for (i = 0; i < nSelectedBox; i++) {
// Modify ... ( CHANGE )
				if( pDoc->m_aSelectYosoSagyogun[i].nKishuId != nGraphKishu &&
					nGraphKishu != -1 )
//				if( pDoc->m_aSelectYosoSagyogun[i].nKishuId != nGraphKishu )
// By Y.Itabashi (xxxxx) 2007.03.06
					continue;

				int nIndex = ( nGraphKishu == -1 ) ? pDoc->m_aSelectYosoSagyogun[i].nIndex : pDoc->m_aSelectYosoSagyogun[i].nIndexKishu;
				if (m_aZahyoDrag[nIndex].nIndex == pZahyoDrag->nIndex)
//				if (m_aZahyoDrag[pDoc->m_aSelectedBox[i]].nIndex == pZahyoDrag->nIndex)
					break;
			}
// By Y.Itabashi (xxxxx) 2007.02.27
			if (i == nSelectedBox) {
				ResetSelectedBox();
				AddSelect(pZahyoDrag->nIndex);
// Modify ... ( CHANGE )
			} else{
				int nIndex = ( nGraphKishu == -1 ) ? pDoc->m_aSelectYosoSagyogun[i].nIndex : pDoc->m_aSelectYosoSagyogun[i].nIndexKishu;
				m_nSelectRemoveIndex = m_aZahyoDrag[nIndex].nIndex;
			}
//				m_nSelectRemoveIndex = m_aZahyoDrag[pDoc->m_aSelectedBox[i]].nIndex;
// By Y.Itabashi (xxxxx) 2007.02.27
		}

		m_pointDrag = point;
		m_nMouseMoveMode = MOUSE_DRAG;
// Modify ... ( ADD )
		pDoc->m_pDragWnd = GetParentFrame();
// By Y.Itabashi (xxxxx) 2007.02.27
	}

// Modify ... ( ADD )
	pDoc->AddSelectKoteiOtherWindow();
// By Y.Itabashi (xxxxx) 2007.02.27
}

//*****************************************************************************************************
//  1. ֐
//		CManualEditView1::OnLButtonUp
//----------------------------------------------------------------------------------------------------
//  2. @\
//		}EX{^Abv
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		UINT		nFlags			[I] zL[̏
//		CPoint		point			[I] }EXJ[\̍W
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//----------------------------------------------------------------------------------------------------
//  5. Tv
//		NbNꂽWLZB
//----------------------------------------------------------------------------------------------------
//  6. l
//----------------------------------------------------------------------------------------------------
//  7. 
//		2006.09.01 S.Aizawa(xxx) VK쐬
//*****************************************************************************************************
void CManualEditView1::OnLButtonUp(UINT nFlags, CPoint point)
{
	switch (m_nMouseMoveMode) {
	case MOUSE_SELECT:
		DrawFocusRect(m_rectSelect);
		SelectRect();
		ReleaseCapture();
		break;
	}

	if (m_nSelectRemoveIndex != -1) {
		RemoveSelect(m_nSelectRemoveIndex);
		m_nSelectRemoveIndex = -1;
	}

	m_nMouseMoveMode = MOUSE_NONE;

// Modify ... ( ADD )
	GetDocument()->m_pDragWnd = NULL;
// By Y.Itabashi (xxxxx) 2007.02.28

	CManualEditView::OnLButtonUp(nFlags, point);
}

//*****************************************************************************************************
//  1. ֐
//		CManualEditView1::OnMouseMove
//----------------------------------------------------------------------------------------------------
//  2. @\
//		}EXړ
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		UINT		nFlags			[I] zL[̏
//		CPoint		point			[I] }EXJ[\̍W
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//----------------------------------------------------------------------------------------------------
//  5. Tv
//		NbNĂꍇ̓hbOJnAhbvꂽړsB
//----------------------------------------------------------------------------------------------------
//  6. l
//----------------------------------------------------------------------------------------------------
//  7. 
//		2006.09.01 S.Aizawa(xxx) VK쐬
//*****************************************************************************************************
void CManualEditView1::OnMouseMove(UINT nFlags, CPoint point)
{
	CManualEditDocument *pDoc = GetDocument();

	switch (m_nMouseMoveMode) {
	case MOUSE_SELECT:
		DrawFocusRect(m_rectSelect);
		m_rectSelect.right = point.x;
		m_rectSelect.bottom = point.y;
		DrawFocusRect(m_rectSelect);
		break;
	case MOUSE_DRAG:
		// hbOɓ_łƃhbOĝœ_ł~߂
		pDoc->StopBlink(TRUE);
// Modify ... ( ADD )
		if( pDoc->m_pDragWnd && pDoc->m_pDragWnd != GetParentFrame() )
			break;
// By Y.Itabashi (xxxxx) 2007.02.28

		// NbNĂȂhbOlp\
		CRectTrackerEx cRectTracker(GetSelectRect() - GetScrollPosition(), CRectTracker::hatchedBorder);
		pDoc->m_pDrop = NULL;
		m_pointDragOld = 0;
		if (cRectTracker.Track(AfxGetMainWnd(), m_pointDrag, FALSE, NULL)) {
			if (!pDoc->m_bSelectKitting) {
				// Ot̃o[ŃhbvꂽOt̎ނɂH܂͗vfƌQ̈ړ
				if (pDoc->m_pDrop != NULL)
					MoveDrag();
			} else {
				// LbgƂIĂăTuCGAŃhbvꂽLbg
				if (pDoc->m_nDropSublineId != -1)
					CancelKitting();
			}
		}
		pDoc->StopBlink(FALSE);
		pDoc->UpdateAllViews(NULL, UPDATE_ERASE_MOVE_TRIANGLE);
		m_nMouseMoveMode = MOUSE_NONE;
// Modify ... ( ADD )
		pDoc->m_pDragWnd = NULL;
// By Y.Itabashi (xxxxx) 2007.02.28
		m_nSelectRemoveIndex = -1;
		break;
	}

	CManualEditView::OnMouseMove(nFlags, point);
}

//*****************************************************************************************************
//  1. ֐
//		CManualEditView1::OnUserDrag
//----------------------------------------------------------------------------------------------------
//  2. @\
//		hbÕ}EXړ
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		WPARAM	wParam			[I] EBhEbZ[Wp[^P
//		LPARAM	lParam			[I] EBhEbZ[Wp[^Q
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		LRESULT		0
//----------------------------------------------------------------------------------------------------
//  5. Tv
//		}EXJ[\ړ\Ȉʒuɂꍇ́Aړ̎Op`\B
//----------------------------------------------------------------------------------------------------
//  6. l
//----------------------------------------------------------------------------------------------------
//  7. 
//		2006.09.01 S.Aizawa(xxx) VK쐬
//*****************************************************************************************************
LRESULT CManualEditView1::OnUserDrag(WPARAM wParam, LPARAM lParam)
{
	CManualEditDocument *pDoc = GetDocument();

	CPoint point;
	::GetCursorPos(&point);
	ScreenToClient(&point);

// Modify ... ( ADD )
	if( pDoc->m_pDragWnd != GetParentFrame() )
		return 0;

	int nGraphKishu = ((CManualEditChildWnd *)GetParentFrame())->m_nGraphKishu;
// By Y.Itabashi (xxxxx) 2007.02.28

	// LbgƂIĂꍇ͉Ȃ
	if (!pDoc->m_bSelectKitting) {
		if (wParam == USER_DRAG_ENTER || wParam == USER_DRAG_OVER) {
// Modify ... ( CHANGE )
			if (pDoc->m_aSelectYosoSagyogun.GetSize() != 0) {
				int nIndex = ( nGraphKishu == -1 ) ? pDoc->m_aSelectYosoSagyogun[0].nIndex : pDoc->m_aSelectYosoSagyogun[0].nIndexKishu;
				SZahyoDrag &cZahyoDrag = m_aZahyoDrag[nIndex];
//			if (pDoc->m_aSelectedBox.GetSize() != 0) {
//				SZahyoDrag &cZahyoDrag = m_aZahyoDrag[pDoc->m_aSelectedBox[0]];
// By Y.Itabashi (xxxxx) 2007.02.27

				CRect rect;
				pDoc->m_pDrop = CheckZahyoDrop(point, rect);
				if (pDoc->m_pDrop != NULL
						&& pDoc->m_pDrop->pGraphBlock->bKitting == cZahyoDrag.pGraphBlock->bKitting
						&& (cZahyoDrag.pGraphBlock->nSublineId != pDoc->m_pDrop->pGraphBlock->nSublineId
						|| cZahyoDrag.nSagyoshaId != pDoc->m_pDrop->nSagyoshaId
						|| !CheckSelect(pDoc->m_pDrop->pGraphBlock))) {
					int nIndex1 = pDoc->m_pDrop->nIndex;
					int nIndex2 = nIndex1 - 1;

					if (nIndex2 == -1
							|| m_aZahyoDrop[nIndex1].bLastBlock
							|| m_aZahyoDrop[nIndex1].nSagyoshaId != m_aZahyoDrop[nIndex2].nSagyoshaId
							|| !m_aZahyoDrop[nIndex1].pGraphBlock->bKyotsuKotei
							|| !m_aZahyoDrop[nIndex2].pGraphBlock->bKyotsuKotei
							|| m_aZahyoDrop[nIndex1].pGraphBlock->nGroupNo != m_aZahyoDrop[nIndex2].pGraphBlock->nGroupNo) {
						if (wParam == USER_DRAG_ENTER)
							m_pointDragOld = CPoint(0, 0);

						// Ot̃o[Ȃړ̎Op\
						DrawMoveTriangle(pDoc->m_pDrop->pointTriangle - GetScrollPosition());

						return 0;
					}
				}
			}
		}

		// Ot̃o[łȂȂړ̎Op
		DrawMoveTriangle(0);
		pDoc->m_pDrop = NULL;
	} else {
		SZahyoSubline *pZahyoSubline = GetZahyoSubline(point);
		if (pZahyoSubline != NULL)
			pDoc->m_nDropSublineId = pZahyoSubline->nSublineId;
	}

	return 0;
}

//*****************************************************************************************************
//  1. ֐
//		CManualEditView1::DrawMoveTriangle
//----------------------------------------------------------------------------------------------------
//  2. @\
//		ړ̎Op``揈
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		CPoint		point			[I] Op``悷W
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//----------------------------------------------------------------------------------------------------
//  5. Tv
//		w肳ꂽʒuɎOp``悷BȑÖʒu͏B
//----------------------------------------------------------------------------------------------------
//  6. l
//----------------------------------------------------------------------------------------------------
//  7. 
//		2006.09.01 S.Aizawa(xxx) VK쐬
//*****************************************************************************************************
void CManualEditView1::DrawMoveTriangle(CPoint point)
{
	if (point != m_pointDragOld) {
		// `惂[hݒ
		CDC *pDC = GetDC();
		int nDrawMode = pDC->SetROP2(R2_XORPEN);
		CBrush *pBrush = pDC->SelectObject(&m_brushMoveDrag);
		CPen *pPen = pDC->SelectObject((CPen *)pDC->SelectStockObject(NULL_PEN));

		// ȑO̎Op`
		if (m_pointDragOld != CPoint(0, 0)) {
			CRect rect(m_pointDragOld.x - 8, m_pointDragOld.y - 6, m_pointDragOld.x - 1, m_pointDragOld.y + 6);
			DrawRightTriangle(pDC, rect);
			m_pointDragOld = 0;
		}

		// VʒuɎOp``
		if (point != CPoint(0, 0)) {
			CRect rect(point.x - 8, point.y - 6, point.x - 1, point.y + 6);
			DrawRightTriangle(pDC, rect);
		}
		m_pointDragOld = point;

		pDC->SelectObject(pPen);
		pDC->SelectObject(pBrush);
		pDC->SetROP2(nDrawMode);
		ReleaseDC(pDC);
	}
}

//*****************************************************************************************************
//  1. ֐
//		CManualEditView1::MoveKotei
//----------------------------------------------------------------------------------------------------
//  2. @\
//		hbOɂHړ
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//----------------------------------------------------------------------------------------------------
//  5. Tv
//		hbOɂHړsB
//----------------------------------------------------------------------------------------------------
//  6. l
//----------------------------------------------------------------------------------------------------
//  7. 
//		2006.09.01 S.Aizawa(xxx) VK쐬
//*****************************************************************************************************
void CManualEditView1::MoveDrag()
{
// Modify ... ( ADD )
	CManualEditChildWnd *pWnd = (CManualEditChildWnd *)GetParentFrame();
// By Y.Itabashi (xxxxx) 2007.02.26
	CManualEditDocument *pDoc = GetDocument();
	int i;

// Modify ... ( ADD )
	int nGraphKishu;
	int nKishu;
	int nSize;
	BOOL bSetGraph;
	int nSetIndex;
	CGraphBlockPtrArray aGraphBlockFrom;
	CSelectYosoSagyogunArray m_aSelectYosoSagyogunBack;
	CReferenceYosoSagyogunArray m_aRefYosoSagyogunBack;

	m_aSelectYosoSagyogunBack.RemoveAll();
	for( i = 0; i < pDoc->m_aSelectYosoSagyogun.GetSize(); i++ )
		m_aSelectYosoSagyogunBack.Add( pDoc->m_aSelectYosoSagyogun[i] );

	m_aRefYosoSagyogunBack.RemoveAll();
	for( i = 0; i < pDoc->m_aRefYosoSagyogun.GetSize(); i++ )
		m_aRefYosoSagyogunBack.Add( pDoc->m_aRefYosoSagyogun[i] );
	// オHȂ炻I
	pDoc->AddSelectAutoKotei();
// By Y.Itabashi (xxxxx) 2007.03.07

	SGraphBlock *pGraphBlockTo = pDoc->m_pDrop->pGraphBlock;
// Modify ... ( CHANGE )
	int nIndex = ( pWnd->m_nGraphKishu == -1 ) ? pDoc->m_aSelectYosoSagyogun[0].nIndex : pDoc->m_aSelectYosoSagyogun[0].nIndexKishu;
	SGraphBlock *pGraphBlockFrom = m_aZahyoDrag[nIndex].pGraphBlock;
//	SGraphBlock *pGraphBlockFrom = m_aZahyoDrag[pDoc->m_aSelectedBox[0]].pGraphBlock;
// By Y.Itabashi (xxxxx) 2007.02.27
	int nSublineIdFrom = pGraphBlockFrom->nSublineId;
	int nSublineIdTo = pGraphBlockTo->nSublineId;

	// CKt@CJĂG[
	if (g_pDataManager->m_bOpenLineKiseiMatrix) {
		g_pSystem->DispMessage("E006002");
		return;
	}

	// ^Kt@CJĂG[
	if (g_pDataManager->m_bOpenKatashikiKiseiMatrix) {
		g_pSystem->DispMessage("E006102");
		return;
	}

	// @ʕ\ŋʍH܂܂ĂG[
// Modify ... ( CHANGE )
	int nSelectSize = pDoc->m_aSelectYosoSagyogun.GetSize();
	if (pWnd->m_nGraphKishu != -1) {
//	if (pDoc->m_nGraphKishu != -1) {
// By Y.Itabashi (xxxxx) 2007.02.26
		for (int i = 0; i < nSelectSize; i++) {
// Modify ... ( CHANGE )
			int nIndex = ( pWnd->m_nGraphKishu == -1 ) ? pDoc->m_aSelectYosoSagyogun[i].nIndex : pDoc->m_aSelectYosoSagyogun[i].nIndexKishu;
			SZahyoDrag &cZahyoDrag = m_aZahyoDrag[nIndex];
//			SZahyoDrag &cZahyoDrag = m_aZahyoDrag[pDoc->m_aSelectedBox[i]];
// By Y.Itabashi (xxxxx) 2007.02.27
			if (cZahyoDrag.pGraphBlock->bKyotsuKotei) {
				g_pSystem->DispMessage("E013001");
				goto ERR;	// Modify... ( CHANGE )
			}
		}
	}

	// H`FbN
// Modify ... ( CHANGE )		H`FbN֐
	for (i = 0; i < nSelectSize; i++) {
// Modify ... ( CHANGE )
		int nIndex = ( pWnd->m_nGraphKishu == -1 ) ? pDoc->m_aSelectYosoSagyogun[i].nIndex : pDoc->m_aSelectYosoSagyogun[i].nIndexKishu;
		if( !pDoc->CheckSameKoteiMove( m_aZahyoDrag[nIndex].pGraphBlock, pGraphBlockTo, pDoc->m_pDrop->bLastBlock ) ){
//		if( !pDoc->CheckSameKoteiMove( m_aZahyoDrag[pDoc->m_aSelectedBox[i]].pGraphBlock, pGraphBlockTo, pDoc->m_pDrop->bLastBlock ) ){
// By Y.Itabashi (xxxxx) 2007.02.27
				goto ERR;	// Modify... ( CHANGE )
		}
	}
// By Y.Itabashi (xxxxx) 2007.02.10

	// ŐVړtONA
	g_pDataManager->ClearNewMoveFlag();

// Modify ... ( CHANGE )
	nSize = pDoc->m_aSelectYosoSagyogun.GetSize();
	bSetGraph = TRUE;
	nSetIndex = -1;
	while( bSetGraph ){

		bSetGraph = FALSE;

		int nIndexMin = m_aZahyoDrag.GetSize();
		for (i = 0; i < nSize; i++){

			if( pWnd->m_nGraphKishu != pDoc->m_aSelectYosoSagyogun[i].nKishuId &&
				pWnd->m_nGraphKishu != -1 )
				continue;

			int nIndex = ( pWnd->m_nGraphKishu == -1 ) ? pDoc->m_aSelectYosoSagyogun[i].nIndex : pDoc->m_aSelectYosoSagyogun[i].nIndexKishu;
			if( nSetIndex < nIndex ){
				nIndexMin = ( nIndex < nIndexMin ) ? nIndex : nIndexMin;
				bSetGraph = TRUE;
			}
		}
		if( bSetGraph ){
			aGraphBlockFrom.Add(m_aZahyoDrag[nIndexMin].pGraphBlock);
			nSetIndex = nIndexMin;
		}
	}
//	int nSize = pDoc->m_aSelectedBox.GetSize();
//	for (i = 0; i < nSize; i++)
//		aGraphBlockFrom.Add(m_aZahyoDrag[pDoc->m_aSelectedBox[i]].pGraphBlock);
// By Y.Itabashi (xxxxx) 2007.03.07

// Modify ... ( ADD )
	// ړÖʒuݒ
	for( nKishu = 0; nKishu < g_pDataManager->GetKishuNum(); nKishu++ ){
		CString sCheckKoteiName;
		CString sCheckYosoSagyogunName;
		int nCheckYosoSagyogunId = -1;

		for( i = 0; i < aGraphBlockFrom.GetSize(); i++ ){
			SGraphBlock *pGraphBlockFrom = aGraphBlockFrom[i];

			if( pGraphBlockFrom->nKishuId != nKishu )
				continue;

			if( sCheckKoteiName.IsEmpty() ){
				sCheckKoteiName = pGraphBlockFrom->sKoteiName;
				sCheckYosoSagyogunName = pGraphBlockFrom->sYosoSagyogunName;
				nCheckYosoSagyogunId = pGraphBlockFrom->aYosoSagyogunId[0];
			}

			g_pDataManager->SetMoveBeforeSagyojun(nSublineIdFrom, nSublineIdTo,
				pGraphBlockFrom->sKoteiName, pGraphBlockFrom->sYosoSagyogunName,
				sCheckKoteiName, sCheckYosoSagyogunName, nCheckYosoSagyogunId,
				pGraphBlockFrom->aYosoSagyogunId, pGraphBlockFrom->nKishuId, 
				pDoc->m_nGraphKind == GRAPH_KOTEI ? eKojunCheckTypeKotei : eKojunCheckTypeYosoSagyogun );
		}
	}
/*	for( i = 0; i < aGraphBlockFrom.GetSize(); i++ ){
		SGraphBlock *pGraphBlockFrom = aGraphBlockFrom[i];
		g_pDataManager->SetMoveBeforeSagyojun(nSublineIdFrom,
			pGraphBlockFrom->sKoteiName, pGraphBlockFrom->sYosoSagyogunName,
			pGraphBlockFrom->aYosoSagyogunId, pGraphBlockFrom->nKishuId, 
			pDoc->m_nGraphKind == GRAPH_KOTEI ? eKojunCheckTypeKotei : eKojunCheckTypeYosoSagyogun );
	}*/
// By Y.Itabashi (xxxxx) 2007.02.28

	pDoc->MoveItem(nSublineIdFrom, aGraphBlockFrom, nSublineIdTo, pDoc->m_pDrop->pGraphBlock, pDoc->m_pDrop->nSagyoshaId, pDoc->m_pDrop->bLastBlock);

	// HK`FbN
// Modify ... ( CHANGE )
	if (!g_pDataManager->CheckKojunKisei(nSublineIdFrom, nSublineIdTo, pDoc->m_nGraphKind == GRAPH_KOTEI ? eKojunCheckTypeKotei : eKojunCheckTypeYosoSagyogun)) {
//	if (!g_pDataManager->CheckKojunKisei(nSublineIdTo, pDoc->m_nGraphKind == GRAPH_KOTEI ? eKojunCheckTypeKotei : eKojunCheckTypeYosoSagyogun)) {
// By Y.Itabashi (xxxxx) 2007.02.07
		g_pDataManager->RestoreUndoData();
		goto ERR;	// Modify... ( CHANGE )
	}

// Modify ... ( ADD )
	g_pDataManager->InitMoveBeforeSagyojun();
// By Y.Itabashi (xxxxx) 2007.02.06

	// ڕW^Ng`FbN
// Modify ... ( CHANGE )
	nGraphKishu = ((CManualEditChildWnd *)GetParentFrame())->m_nGraphKishu;
	for (i = 0; i < nSelectSize; i++) {
		if( pDoc->m_aSelectYosoSagyogun[i].nKishuId != nGraphKishu &&
			nGraphKishu != -1 )
//		if( pDoc->m_aSelectYosoSagyogun[i].nKishuId != nGraphKishu )
			continue;

		int nIndex = ( pWnd->m_nGraphKishu == -1 ) ? pDoc->m_aSelectYosoSagyogun[i].nIndex : pDoc->m_aSelectYosoSagyogun[i].nIndexKishu;
		SZahyoDrag &cZahyoDrag = m_aZahyoDrag[nIndex];
		if (!g_pDataManager->CheckMokuhyoTactJoukagen(nSublineIdTo, pDoc->m_pDrop->nSagyoshaId, cZahyoDrag.pGraphBlock->nKishuId, pWnd->m_nGraphKishu)) {
//		SZahyoDrag &cZahyoDrag = m_aZahyoDrag[pDoc->m_aSelectedBox[i]];
//		if (!g_pDataManager->CheckMokuhyoTactJoukagen(nSublineIdTo, pDoc->m_pDrop->nSagyoshaId, cZahyoDrag.pGraphBlock->nKishuId)) {
// By Y.Itabashi (xxxxx) 2007.03.07
			if(g_pSystem->DispMessage("W013002") == IDCANCEL) {
				g_pDataManager->RestoreUndoData();
				goto ERR;	// Modify... ( CHANGE )
			} else
				break;
		}
	}

// --Add 2007/03/02 aizawa sD-147
	// TuCԈړ̏ꍇACK}gNX̃TuCXV
	if (nSublineIdFrom != nSublineIdTo)
		g_pDataManager->UpdateLineKiseiSubline(nSublineIdFrom, nSublineIdTo);
// --Add

	// f[^XVtOݒ
	g_pDataManager->SetUpdate();

	// IZbg
	ResetSelectedBox();

	// ʍXV
	GetDocument()->UpdateGraph(FALSE);

	// ݂̃f[^Undoobt@ɕۑ
	g_pDataManager->SaveUndoBuf();

// Modify ... ( ADD )
	return;

ERR:
	pDoc->m_aSelectYosoSagyogun.RemoveAll();
	for( i = 0; i < m_aSelectYosoSagyogunBack.GetSize(); i++ )
		pDoc->m_aSelectYosoSagyogun.Add( m_aSelectYosoSagyogunBack[i] );

	pDoc->m_aRefYosoSagyogun.RemoveAll();
	for( i = 0; i < m_aRefYosoSagyogunBack.GetSize(); i++ )
		pDoc->m_aRefYosoSagyogun.Add( m_aRefYosoSagyogunBack[i] );
// By Y.Itabashi (xxxxx) 2007.03.07
}

// Lbg
void CManualEditView1::CancelKitting()
{
	CManualEditDocument *pDoc = GetDocument();
	CManualEditChildWnd *pWnd = (CManualEditChildWnd *)GetParentFrame();
// --Add 2007/03/05 aizawa sD-199
	int nSublineId;
// --Add

	// LbgtONA
	g_pDataManager->ClearKittingCancelFlag();

	// Lbgf[^擾
	g_pDataManager->GetKittingData();

	// IĂ镔ĩLbg
// Modify ... ( CHANGE )
	int nGraphKishu = ((CManualEditChildWnd *)GetParentFrame())->m_nGraphKishu;
	int nSize = pDoc->m_aSelectYosoSagyogun.GetSize();
	for (int i = 0; i < nSize; i++) {
		if( pDoc->m_aSelectYosoSagyogun[i].nKishuId != nGraphKishu &&
			nGraphKishu != -1 )
			continue;

		int nGraphKishu = ((CManualEditChildWnd *)GetParentFrame())->m_nGraphKishu;
		int nIndex = ( nGraphKishu == -1 ) ? pDoc->m_aSelectYosoSagyogun[i].nIndex : pDoc->m_aSelectYosoSagyogun[i].nIndexKishu;
		SGraphBlock *pGraphBlock = m_aZahyoDrag[nIndex].pGraphBlock;
		g_pDataManager->CancelKitting(pGraphBlock->nSublineId, pGraphBlock->sKoteiName);
	}
/*	int nSize = pDoc->m_aSelectedBox.GetSize();
	for (int i = 0; i < nSize; i++) {
		SGraphBlock *pGraphBlock = m_aZahyoDrag[pDoc->m_aSelectedBox[i]].pGraphBlock;
		g_pDataManager->CancelKitting(pGraphBlock->nSublineId, pGraphBlock->sKoteiName);
	}*/
// By Y.Itabashi (xxxxx) 2007.03.06

// --Add 2007/03/05 aizawa sD-199
	// ^NgI[o`FbN
	int nSublineNum = g_pDataManager->GetSublineNum();
	for (nSublineId = 0; nSublineId < nSublineNum; nSublineId++) {
		SSubline *pSubline = g_pDataManager->GetSublineData(nSublineId);
		int nYosoSagyogunNum = pSubline->aYosoSagyogun.GetSize();
		for (int nYosoSagyogunId = 0; nYosoSagyogunId < nYosoSagyogunNum; nYosoSagyogunId++) {
			SYosoSagyogun &cYosoSagyogun = pSubline->aYosoSagyogun[nYosoSagyogunId];
			// LbgɂƂvfƌQ`FbN
			if (cYosoSagyogun.bKittingCancel) {
				if (pWnd->m_nGraphKishu == -1) {
					// dϕ\
					int nKishuSagyoNum = cYosoSagyogun.aKishuSagyo.GetSize();
					for (int nKishuId = 0; nKishuId < nKishuSagyoNum; nKishuId++) {
						SKishuSagyo &cKishuSagyo = cYosoSagyogun.aKishuSagyo[nKishuId];
						if (cKishuSagyo.nSagyoshaId != -1) {
							// ڕW^Ng`FbN
							if (!g_pDataManager->CheckMokuhyoTactJoukagen(nSublineId, cKishuSagyo.nSagyoshaId, nKishuId, pWnd->m_nGraphKishu)) {
								if(g_pSystem->DispMessage("W013002") == IDCANCEL) {
									g_pDataManager->RestoreUndoData();
									return;
								} else
									goto tact_check_ok;
							}
						}
					}
				} else {
					// @ʕ\
					SKishuSagyo &cKishuSagyo = cYosoSagyogun.aKishuSagyo[pWnd->m_nGraphKishu];
					if (cKishuSagyo.nSagyoshaId != -1) {
						// ڕW^Ng`FbN
						if (!g_pDataManager->CheckMokuhyoTactJoukagen(nSublineId, cKishuSagyo.nSagyoshaId, pWnd->m_nGraphKishu, pWnd->m_nGraphKishu)) {
							if(g_pSystem->DispMessage("W013002") == IDCANCEL) {
								g_pDataManager->RestoreUndoData();
								return;
							} else
								goto tact_check_ok;
						}
					}
				}
			}
		}
	}
tact_check_ok:
// --Add

	// Lbgiۑ
	g_pDataManager->SetBuhinKitting();

	// LbgƎҐ
	CIntArrayEx aSublineId;
// --Delete 2007/03/05 aizawa sD-199
//	int nSublineNum = g_pDataManager->GetSublineNum();
// --Delete
// --Change 2007/03/05 aizawa sD-199
//	for (int nSublineId = 0; nSublineId < nSublineNum; nSublineId++) {
	for (nSublineId = 0; nSublineId < nSublineNum; nSublineId++) {
// --Change
		SSubline *pSubline = g_pDataManager->GetSublineData(nSublineId);
		if (pSubline->bSagyoshaWaritsuke)
			aSublineId.Add(nSublineId);
	}
	g_pDataManager->JidoHensei1Kitting(aSublineId);

// Modify ... ( ADD )
	// ړtONA[
	g_pDataManager->ClearNewMoveFlag();
// By Y.Itabashi (xxxxx) 2007.03.05

	// IZbg
	ResetSelectedBox();

	// f[^XVtOݒ
	g_pDataManager->SetUpdate();

	// ʍXV
	GetDocument()->UpdateGraph(TRUE);

	// ݂̃f[^Undoobt@ɕۑ
	g_pDataManager->SaveUndoBuf();
}

// XP[p[^ݒ
void CManualEditView1::SetScaleParamaeter()
{
	m_nLeftMargin = 40;
	m_nTopMargin = 80;
	m_nRightMargin = 20;
	m_nBottomMargin = 40;
	m_nBarWidth = 80;
	m_nLeftSpacing = 20;
	m_nBarSpacing = 30;
}

void CManualEditView1::DrawFocusRect(CRect rect)
{
	if (rect.TopLeft() != rect.BottomRight()) {
		CDC *pDC = GetDC();

		rect.NormalizeRect();
		pDC->DrawFocusRect(rect);

		ReleaseDC(pDC);
	}
}

void CManualEditView1::BlinkSelectedBox(BOOL bBlink)
{
	CManualEditDocument *pDoc = GetDocument();
// Modify ... ( CHANGE )
	int nGraphKishu = ((CManualEditChildWnd *)GetParentFrame())->m_nGraphKishu;
	int nSelectedBox = pDoc->m_aSelectYosoSagyogun.GetSize();
//	int nSelectedBox = pDoc->m_aSelectedBox.GetSize();
// By Y.Itabashi (xxxxx) 2007.02.27
	if (nSelectedBox == 0)
		return;

	int i, j;
	CArray <CRect, CRect&> aBlinkRect;
	CPoint point = GetScrollPosition();

// Modify ... ( ADD )
	if( nGraphKishu == -1 ){
		int nCheckIndex = -1;
		while( 1 ){
			int nMinIndex = -1;
			for (i = 0; i < nSelectedBox; i++) {

				int nIndex = pDoc->m_aSelectYosoSagyogun[i].nIndex;

				if( nCheckIndex < nIndex && nMinIndex == -1 )
					nMinIndex = nIndex;

				if( nCheckIndex >= nIndex )
					continue;

				nMinIndex = ( nMinIndex > nIndex ) ? nIndex : nMinIndex;
			}

			if( nCheckIndex == nMinIndex || nMinIndex == -1 )
				break;

			nCheckIndex = nMinIndex;
			CRect rectSelectedBox = m_aZahyoDrag[nMinIndex].rect - point;

			int nBlinkRect = aBlinkRect.GetSize();
			for (j = 0; j < nBlinkRect; j++) {
				CRect &rectBlink = aBlinkRect[j];

				if (rectSelectedBox.left == rectBlink.left) {
					if (rectSelectedBox.bottom == rectBlink.top) {
						rectBlink.top = rectSelectedBox.top;
						break;
					}

					if (rectSelectedBox.top == rectBlink.bottom) {
						 rectBlink.bottom = rectSelectedBox.bottom;
						break;
					}
				}
			}

			if (j == nBlinkRect)
				aBlinkRect.Add(rectSelectedBox);
		}
	}else{
// By Y.Itabashi (xxxxx) 2007.02.28
	for (i = 0; i < nSelectedBox; i++) {

// Modify ... ( CHANGE )
		if( nGraphKishu != pDoc->m_aSelectYosoSagyogun[i].nKishuId )
			continue;

		int nIndex = pDoc->m_aSelectYosoSagyogun[i].nIndexKishu;
		CRect rectSelectedBox = m_aZahyoDrag[nIndex].rect - point;
//		CRect rectSelectedBox = m_aZahyoDrag[pDoc->m_aSelectedBox[i]].rect - point;
// By Y.Itabashi (xxxxx) 2007.02.20

		int nBlinkRect = aBlinkRect.GetSize();
		for (j = 0; j < nBlinkRect; j++) {
			CRect &rectBlink = aBlinkRect[j];

			if (rectSelectedBox.left == rectBlink.left) {
				if (rectSelectedBox.bottom == rectBlink.top) {
					rectBlink.top = rectSelectedBox.top;
					break;
				}

				if (rectSelectedBox.top == rectBlink.bottom) {
					 rectBlink.bottom = rectSelectedBox.bottom;
					break;
				}
			}
		}

		if (j == nBlinkRect)
			aBlinkRect.Add(rectSelectedBox);
	}
// Modify ... ( ADD )
	}
// By Y.Itabashi (xxxxx) 2007.02.28

	if (bBlink) {
		CDC *pDC = GetDC();
		CPen *pPenOrg = pDC->SelectObject(&m_penSelected);
		CBrush *pBrushOrg = (CBrush *)pDC->SelectStockObject(NULL_BRUSH);

		for (j = 0; j < aBlinkRect.GetSize(); j++) {
			CRect rect(aBlinkRect[j]);
			rect.right++;
			rect.bottom++;
			pDC->Rectangle(rect);
		}

		pDC->SelectObject(pPenOrg);
		pDC->SelectObject(pBrushOrg);

		ReleaseDC(pDC);
	} else {
		for (j = 0; j < aBlinkRect.GetSize(); j++) {
			CRect rect(aBlinkRect[j]);
			rect.InflateRect(1, 1);
			InvalidateRect(rect, FALSE);
		}
	}
}

void CManualEditView1::EraseSelectedBox()
{
	CManualEditDocument *pDoc = GetDocument();
	pDoc->UpdateAllViews(NULL, UPDATE_SELECT_BLINK, (CObject *)FALSE);
}

void CManualEditView1::ResetSelectedBox()
{
	CManualEditDocument *pDoc = GetDocument();

	EraseSelectedBox();
// Modify ... ( CHANGE )
	pDoc->m_aSelectYosoSagyogun.RemoveAll();
	pDoc->InitReferenceYosoSagyogun();
	this->Invalidate();
//	pDoc->m_aSelectedBox.RemoveAll();
// By Y.Itabashi (xxxxx) 2007.03.04
}

void CManualEditView1::SelectRect()
{
	CManualEditDocument *pDoc = GetDocument();
	CRect rectSelect = m_rectSelect;
	rectSelect.NormalizeRect();
	rectSelect += GetScrollPosition();
// Modify ... ( ADD )
	int nGraphKishu = ((CManualEditChildWnd *)GetParentFrame())->m_nGraphKishu;
// By Y.Itabashi (xxxxx) 2007.02.22

	// Wz̒w肳ꂽʒu܂ގlp`
	int nLeft = 0;
	int nSize = m_aZahyoDrag.GetSize();
	for (int i = 0; i < nSize; i++) {
		CRect &rect = m_aZahyoDrag[i].rect;
		if (rectSelect.PtInRect(rect.TopLeft()) && rectSelect.PtInRect(rect.BottomRight())) {
			if (nLeft == 0 || nLeft == rect.left) {
				AddSelect(i);

// Modify ... ( CHANGE )
//				if( pDoc->m_aSelectedBox.GetSize() == 0 )
				if( pDoc->m_aSelectYosoSagyogun.GetSize() == 0 )
					continue;

//				if (!m_aZahyoDrag[pDoc->m_aSelectedBox[0]].pGraphBlock->bKitting)
				int nIndex = ( nGraphKishu == -1 ) ? pDoc->m_aSelectYosoSagyogun[0].nIndex : pDoc->m_aSelectYosoSagyogun[0].nIndexKishu;
				if (!m_aZahyoDrag[nIndex].pGraphBlock->bKitting)
					nLeft = rect.left;
// By Y.Itabashi (xxxxx) 2007.02.22
			}
		}
	}

// Modify ... ( ADD )
	pDoc->AddSelectKoteiOtherWindow();
// By Y.Itabashi (xxxxx) 2007.02.27
}

// H^vfƌQIǉ
void CManualEditView1::AddSelect(int nIndex)
{
	CManualEditDocument *pDoc = GetDocument();
	SZahyoDrag &cAddZahyoDrag = m_aZahyoDrag[nIndex];

// Modify ... ( ADD )
	// UP4pW[
//	if( cAddZahyoDrag.pGraphBlock->bKitting )
//		return;
// By Y.Itabashi (xxxxx) 2007.02.22

	if (cAddZahyoDrag.pGraphBlock->bKitting != pDoc->m_bSelectKitting) {
		ResetSelectedBox();
		pDoc->m_bSelectKitting = cAddZahyoDrag.pGraphBlock->bKitting;
	}

// Modify ... ( CHANGE )
	int nGraphKishu = ((CManualEditChildWnd *)GetParentFrame())->m_nGraphKishu;
	pDoc->AddSelectKotei( cAddZahyoDrag, nGraphKishu );
//	pDoc->m_aSelectedBox.Add(nIndex);
// By Y.Itabashi (xxxxx) 2007.02.27

	// ʍHȂ瓯O[vԍ̍H^vfƌQI
	if (cAddZahyoDrag.pGraphBlock->bKyotsuKotei) {
		int nSize = m_aZahyoDrag.GetSize();
		for (int i = 0; i < nSize; i++) {
			SZahyoDrag &cZahyoDrag = m_aZahyoDrag[i];
			
// Modify ... ( CHANGE )
			if (cZahyoDrag.rect.left == cAddZahyoDrag.rect.left && cZahyoDrag.pGraphBlock->nGroupNo == cAddZahyoDrag.pGraphBlock->nGroupNo){
				pDoc->AddSelectKotei( cZahyoDrag, nGraphKishu );
//				pDoc->m_aSelectedBox.Add(i);
// Modify ... ( DELETE )
				// オHȂ炻I
/*				for (int j = i + 1; j < nSize; j++) {
					SZahyoDrag &cZahyoDrag = m_aZahyoDrag[j];
					if (cZahyoDrag.nSagyoshaId == cAddZahyoDrag.nSagyoshaId && cZahyoDrag.pGraphBlock->sJido == g_pConst->m_sJido){
						pDoc->AddSelectKotei( cZahyoDrag, nGraphKishu );
					}
					else
						break;
				}*/
// By Y.Itabashi (xxxxx) 2007.03.07
			}
// By Y.Itabashi (xxxxx) 2007.02.27
		}
	}

// Modify ... ( DELETE )
	// オHȂ炻I
/*	int nSize = m_aZahyoDrag.GetSize();
	for (int i = nIndex + 1; i < nSize; i++) {
		SZahyoDrag &cZahyoDrag = m_aZahyoDrag[i];
// Modify ... ( CHANGE )
		if (cZahyoDrag.nSagyoshaId == cAddZahyoDrag.nSagyoshaId && cZahyoDrag.pGraphBlock->sJido == g_pConst->m_sJido){
			pDoc->AddSelectKotei( cZahyoDrag, nGraphKishu );
//			pDoc->m_aSelectedBox.Add(i);
		}
// By Y.Itabashi (xxxxx) 2007.02.27
		else
			break;
	}*/
// By Y.Itabashi (xxxxx) 2007.03.07

// Modify ... ( DELETE )
//	pDoc->m_aSelectedBox.Unique();
//	pDoc->m_aSelectedBox.Sort();
// By Y.Itabashi (xxxxx) 2007.02.27
}

// H^vfƌQI
void CManualEditView1::RemoveSelect(int nIndex)
{
	CManualEditDocument *pDoc = GetDocument();
	SZahyoDrag &cAddZahyoDrag = m_aZahyoDrag[nIndex];
// Modify ... ( ADD )
	int nGraphKishu = ((CManualEditChildWnd *)GetParentFrame())->m_nGraphKishu;
// By Y.Itabashi (xxxxx) 2007.02.22

	EraseSelectedBox();

	// ʍHȂ瓯O[vԍ̍H^vfƌQ
// Modify ... ( CHANGE )
	for (int i = 0; i < pDoc->m_aSelectYosoSagyogun.GetSize(); ) {
//	for (int i = 0; i < pDoc->m_aSelectedBox.GetSize(); ) {
		int nCheckIndex = ( nGraphKishu == -1 ) ? pDoc->m_aSelectYosoSagyogun[i].nIndex : pDoc->m_aSelectYosoSagyogun[i].nIndexKishu;
		SZahyoDrag &cZahyoDrag = m_aZahyoDrag[nCheckIndex];
//		SZahyoDrag &cZahyoDrag = m_aZahyoDrag[pDoc->m_aSelectedBox[i]];
		
		if ( ( ( nGraphKishu == pDoc->m_aSelectYosoSagyogun[i].nKishuId || nGraphKishu == -1 ) &&
			   cZahyoDrag.nIndex == nIndex ) ||
			 ( pDoc->m_aSelectYosoSagyogun[i].bKyotsuKotei &&
			 pDoc->m_aSelectYosoSagyogun[i].nGroupNo == cAddZahyoDrag.pGraphBlock->nGroupNo) ){
//		if (cZahyoDrag.nIndex == nIndex || (cZahyoDrag.pGraphBlock->bKyotsuKotei && cZahyoDrag.rect.left == cAddZahyoDrag.rect.left && cZahyoDrag.pGraphBlock->nGroupNo == cAddZahyoDrag.pGraphBlock->nGroupNo)){
			pDoc->m_aSelectYosoSagyogun.RemoveAt(i);
			pDoc->CancelReferenceYosoSagyogun( cAddZahyoDrag.pGraphBlock->sKoteiName,
				cAddZahyoDrag.pGraphBlock->sYosoSagyogunName );
//			pDoc->m_aSelectedBox.RemoveAt(i);
		}else if( cAddZahyoDrag.pGraphBlock->bKitting &&
			pDoc->m_aSelectYosoSagyogun[i].sKoteiName == cAddZahyoDrag.pGraphBlock->sKoteiName &&
			pDoc->m_aSelectYosoSagyogun[i].sYosoSagyogunName == cAddZahyoDrag.pGraphBlock->sYosoSagyogunName ){
			pDoc->m_aSelectYosoSagyogun.RemoveAt(i);
		}else
			i++;
	}

	pDoc->UpdateAllViews(NULL, UPDATE_EDIT_VIEW);
// By Y.Itabashi (xxxxx) 2007.03.06
}

// IĂSĂ̔͂ޘg߂
CRect CManualEditView1::GetSelectRect()
{
	CManualEditDocument *pDoc = GetDocument();
	CRect rect(0);

// Modify ... ( ADD )
	int nGraphKishu = ((CManualEditChildWnd *)GetParentFrame())->m_nGraphKishu;
	rect.SetRectEmpty();
// By Y.Itabashi (xxxxx) 2007.02.21

// Modify ... ( CHANGE )
	int m_nGraphKishu = ((CManualEditChildWnd *)GetParentFrame())->m_nGraphKishu;
	int nSize = pDoc->m_aSelectYosoSagyogun.GetSize();
	for (int i = 0; i < nSize; i++){
		if( pDoc->m_aSelectYosoSagyogun[i].nKishuId != m_nGraphKishu &&
			m_nGraphKishu != -1 )
			continue;

		int nIndex = ( nGraphKishu == -1 ) ? pDoc->m_aSelectYosoSagyogun[i].nIndex : pDoc->m_aSelectYosoSagyogun[i].nIndexKishu;
		rect.UnionRect(rect, m_aZahyoDrag[nIndex].rect);
	}
//	int nSize = pDoc->m_aSelectedBox.GetSize();
//	for (int i = 0; i < nSize; i++)
//		rect.UnionRect(rect, m_aZahyoDrag[pDoc->m_aSelectedBox[i]].rect);
// By Y.Itabashi (xxxxx) 2007.02.27

	return rect;
}

// w肵ʒu̍H^vfƌQIĂ邩`FbN
BOOL CManualEditView1::CheckSelect(SGraphBlock *pGraphBlock)
{
	CManualEditDocument *pDoc = GetDocument();
// Modify ... ( ADD )
	int nGraphKishu = ((CManualEditChildWnd *)GetParentFrame())->m_nGraphKishu;
// By Y.Itabashi (xxxxx) 2007.02.22

// Modify ... ( CHANGE )
	int nSize = pDoc->m_aSelectYosoSagyogun.GetSize();
//	int nSize = pDoc->m_aSelectedBox.GetSize();
	for (int i = 0; i < nSize; i++) {
		int nIndex = ( nGraphKishu == -1 ) ? pDoc->m_aSelectYosoSagyogun[i].nIndex : pDoc->m_aSelectYosoSagyogun[i].nIndexKishu;
		if (m_aZahyoDrag[nIndex].pGraphBlock == pGraphBlock)
//		if (m_aZahyoDrag[pDoc->m_aSelectedBox[i]].pGraphBlock == pGraphBlock)
			return TRUE;
	}
// By Y.Itabashi (xxxxx) 2007.02.27

	return FALSE;
}

void CManualEditView1::OnChar(UINT nChar, UINT nRepCnt, UINT nFlags)
{
	if (nChar == VK_ESCAPE) {
		ResetSelectedBox();
		SelectSagyosha(0);
	}

	CManualEditView::OnChar(nChar, nRepCnt, nFlags);
}

void CManualEditView1::OnLButtonDblClk(UINT nFlags, CPoint point)
{
	CSplitterEx *pWnd = (CSplitterEx *)GetParent();
	pWnd->ChangeSplit(point);

//	CManualEditView::OnLButtonDblClk(nFlags, point);
}

void CManualEditView1::OnActivateView(BOOL bActivate, CView* pActivateView, CView* pDeactiveView)
{
	CSplitterEx *pWnd = (CSplitterEx *)GetParent();
	pWnd->RecalcLayout();

	CManualEditView::OnActivateView(bActivate, pActivateView, pDeactiveView);
}

// Ǝ҂I
void CManualEditView1::SelectSagyosha(CPoint point)
{
	CManualEditDocument *pDoc = GetDocument();
	CPoint pointScroll = GetScrollPosition();
	point += pointScroll;
	SSelectSagyosha cSelectSagyosha = pDoc->m_cSelectSagyosha;

	int nSize = m_aZahyoSagyosha.GetSize();
	for (int i = 0; i < nSize; i++) {
		SZahyoSagyosha &cZahyoSagyosha = m_aZahyoSagyosha[i];
		if (cZahyoSagyosha.nSublineId != -1 && cZahyoSagyosha.rect.PtInRect(point)) {
			if (cSelectSagyosha.bSelect == TRUE && cSelectSagyosha.nSubnlineId == cZahyoSagyosha.nSublineId && cSelectSagyosha.nSagyoshaId == cZahyoSagyosha.nSagyoshaId)
				pDoc->m_cSelectSagyosha.bSelect = FALSE;
			else {
				pDoc->m_cSelectSagyosha.bSelect = TRUE;
				pDoc->m_cSelectSagyosha.nSubnlineId = cZahyoSagyosha.nSublineId;
				pDoc->m_cSelectSagyosha.nSagyoshaId = cZahyoSagyosha.nSagyoshaId;
			}
			break;
		}
	}

	if (i == nSize)
		pDoc->m_cSelectSagyosha.bSelect = FALSE;

	if (pDoc->m_cSelectSagyosha.bSelect != cSelectSagyosha.bSelect || pDoc->m_cSelectSagyosha.nSubnlineId != cSelectSagyosha.nSubnlineId || pDoc->m_cSelectSagyosha.nSagyoshaId != cSelectSagyosha.nSagyoshaId)
		pDoc->UpdateAllViews(NULL, UPDATE_EDIT_VIEW);
}

// Ǝ҂̐VK}iOɑ}j
void CManualEditView1::OnManualSagyoshaMae() 
{
	CManualEditDocument *pDoc = GetDocument();

	// Ǝ҂IĂ邩`FbN
	if (!pDoc->m_cSelectSagyosha.bSelect) {
		g_pSystem->DispMessage("E022001");
		return;
	}

	// Ǝґ}
	g_pDataManager->InsertSagyosha(pDoc->m_cSelectSagyosha.nSubnlineId, pDoc->m_cSelectSagyosha.nSagyoshaId);

	// ĕ\
	GetDocument()->UpdateGraph(FALSE);

	// ݂̃f[^Undoobt@ɕۑ
	g_pDataManager->SaveUndoBuf();
}

// Ǝ҂̐VK}iɑ}j
void CManualEditView1::OnManualSagyoshaUshiro() 
{
	CManualEditDocument *pDoc = GetDocument();

	// Ǝ҂IĂ邩`FbN
	if (!pDoc->m_cSelectSagyosha.bSelect) {
		g_pSystem->DispMessage("E022001");
		return;
	}

	// Ǝґ}
	g_pDataManager->InsertSagyosha(pDoc->m_cSelectSagyosha.nSubnlineId, pDoc->m_cSelectSagyosha.nSagyoshaId + 1);

	// ĕ\
	GetDocument()->UpdateGraph(FALSE);

	// ݂̃f[^Undoobt@ɕۑ
	g_pDataManager->SaveUndoBuf();
}

// Ǝ҂̍폜
void CManualEditView1::OnManualSagyoshaSakujo() 
{
	CManualEditDocument *pDoc = GetDocument();

	// Ǝ҂IĂ邩`FbN
	if (!pDoc->m_cSelectSagyosha.bSelect) {
		g_pSystem->DispMessage("E023001");
		return;
	}

	if (g_pDataManager->CheckSagyoshaSagyo(pDoc->m_cSelectSagyosha.nSubnlineId, pDoc->m_cSelectSagyosha.nSagyoshaId)) {
		g_pSystem->DispMessage("E023002");
		return;
	}

	// Ǝҍ폜
	g_pDataManager->DeleteSagyosha(pDoc->m_cSelectSagyosha.nSubnlineId, pDoc->m_cSelectSagyosha.nSagyoshaId);

	// ĕ\
	GetDocument()->UpdateGraph(FALSE);

	// ݂̃f[^Undoobt@ɕۑ
	g_pDataManager->SaveUndoBuf();
}

// H^vfƌQ̃Rs[
void CManualEditView1::OnManualCopy() 
{
	CManualEditDocument *pDoc = GetDocument();

// Modify ... ( CHANGE )
	if (pDoc->m_aSelectYosoSagyogun.GetSize() == 0) {
//	if (pDoc->m_aSelectedBox.GetSize() == 0) {
// By Y.Itabashi (xxxxx) 2007.02.27
		g_pSystem->DispMessage("E019001");
		return;
	}

// Modify ... ( CHANGE )
	int nGraphKishu = ((CManualEditChildWnd *)GetParentFrame())->m_nGraphKishu;
	int nIndex = ( nGraphKishu == -1 ) ? pDoc->m_aSelectYosoSagyogun[0].nIndex : pDoc->m_aSelectYosoSagyogun[0].nIndexKishu;
	SGraphBlock *pGraphBlock = m_aZahyoDrag[nIndex].pGraphBlock;
//	SGraphBlock *pGraphBlock = m_aZahyoDrag[pDoc->m_aSelectedBox[0]].pGraphBlock;
// By Y.Itabashi (xxxxx) 2007.02.27
	g_pDataManager->CopyClipboard(pGraphBlock->nSublineId, pGraphBlock->aYosoSagyogunId, pDoc->m_nGraphKind == GRAPH_KOTEI ? "1" : "2");
}

// H^vfƌQ̓\t
void CManualEditView1::OnManualPaste() 
{
	CManualEditDocument *pDoc = GetDocument();

// Modify ... ( CHANGE )
	int nSize = pDoc->m_aSelectYosoSagyogun.GetSize();
//	int nSize = pDoc->m_aSelectedBox.GetSize();
// By Y.Itabashi (xxxxx) 2007.02.27
	if (nSize == 0 || pDoc->m_bSelectKitting) {
		g_pSystem->DispMessage("E020001");
		return;
	}

// Modify ... ( CHANGE )
	int nGraphKishu = ((CManualEditChildWnd *)GetParentFrame())->m_nGraphKishu;
	int nIndex = 0;

	if( nGraphKishu == -1 )
		return;

	for( int nSelect = pDoc->m_aSelectYosoSagyogun.GetSize()-1; nSelect >= 0; nSelect-- ){

		if( nGraphKishu == pDoc->m_aSelectYosoSagyogun[nSelect].nKishuId ){
			if( nIndex < pDoc->m_aSelectYosoSagyogun[nSelect].nIndexKishu ){
				nIndex = pDoc->m_aSelectYosoSagyogun[nSelect].nIndexKishu;
				break;
			}
		}

	}
	SZahyoDrag &cZahyoDrag = m_aZahyoDrag[nIndex];
//	SZahyoDrag &cZahyoDrag = m_aZahyoDrag[pDoc->m_aSelectedBox[nSize - 1]];
// By Y.Itabashi (xxxxx) 2007.03.04
	SGraphBlock *pGraphBlock = cZahyoDrag.pGraphBlock;
	if (!g_pDataManager->PasteClipboard(pGraphBlock->nSublineId, pGraphBlock->aYosoSagyogunId[pGraphBlock->aYosoSagyogunId.GetSize() - 1], pGraphBlock->nKishuId, cZahyoDrag.nSagyoshaId)) {
		g_pSystem->DispMessage("E020002");
		return;
	}

	// OtXV
	GetDocument()->UpdateGraph(FALSE);

	// ݂̃f[^Undoobt@ɕۑ
	g_pDataManager->SaveUndoBuf();
}

//*****************************************************************************************************
//  1. ֐
//		CManualEditView1::OnManualDstr
//----------------------------------------------------------------------------------------------------
//  2. @\
//		DSTRZo
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//----------------------------------------------------------------------------------------------------
//  5. Tv
//		DSTRZo_CAOJB
//----------------------------------------------------------------------------------------------------
//  6. l
//----------------------------------------------------------------------------------------------------
//  7. 
//		2007.02.09 Y.Itabashi VK쐬
//*****************************************************************************************************
void CManualEditView1::OnManualDstr() 
{
	CManualEditDocument *pDoc = GetDocument();
	CManualDstrDlg dlg(this);

// Modify ... ( CHANGE )
	dlg.m_nKishuId = ((CManualEditChildWnd *)GetParentFrame())->m_nGraphKishu;
//	dlg.m_nKishuId = pDoc->m_nGraphKishu;
// By Y.Itabashi (xxxxx) 2007.02.26

	dlg.m_pDoc = pDoc;

	dlg.DoModal();
}

//*****************************************************************************************************
//  1. ֐
//		CManualEditView::AddZahyoDrag
//----------------------------------------------------------------------------------------------------
//  2. @\
//		ƍWǉ
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		CRect		&rect				[I] lp`̍W
//		SGraphBlock	*pGraphBlock		[I] OtubNf[^
//		CString		&sDispText			[I] lpɕ\eLXg
//		int			nKishuId			[I] @ID
//		int			nSagyoshaId			[I] ƎID
//		int			nKind				[I] OtށiH or vfƌQj
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//----------------------------------------------------------------------------------------------------
//  5. Tv
//		m_aZahyoDragɎw肳ꂽWf[^ǉB
//----------------------------------------------------------------------------------------------------
//  6. l
//----------------------------------------------------------------------------------------------------
//  7. 
//		2006.09.01 S.Aizawa(xxx) VK쐬
//*****************************************************************************************************
void CManualEditView1::AddZahyoDrag(const CRect &rect, SGraphBlock *pGraphBlock, int nSagyoshaId)
{
	int nIndex;
	SZahyoDrag *pZahyoDrag = m_aZahyoDrag.AddElement(nIndex);

	pZahyoDrag->rect = rect;
	pZahyoDrag->pGraphBlock = pGraphBlock;
	pZahyoDrag->nSagyoshaId = nSagyoshaId;
	pZahyoDrag->nIndex = nIndex;
}

void CManualEditView1::AddZahyoDrop(const CRect &rect, SGraphBlock *pGraphBlock, int nSagyoshaId, CPoint pointTriangle, BOOL bLastBlock)
{
// Modify ... ( ADD )
	if( !pGraphBlock )
		return;
// By Y.Itabashi (xxxxx) 2007.02.14

	if (!pGraphBlock->bKitting) {
		int nIndex;
		SZahyoDrop *pZahyoDrop = m_aZahyoDrop.AddElement(nIndex);

		pZahyoDrop->rect = rect;
		pZahyoDrop->pGraphBlock = pGraphBlock;
		pZahyoDrop->nSagyoshaId = nSagyoshaId;
		pZahyoDrop->nIndex = nIndex;
		pZahyoDrop->pointTriangle = pointTriangle;
		pZahyoDrop->bLastBlock = bLastBlock;
	}
}

//*****************************************************************************************************
//  1. ֐
//		CManualEditView::CheckZahyoGraph
//----------------------------------------------------------------------------------------------------
//  2. @\
//		w肳ꂽWʒũ|C^擾
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		CPoint		point			[I] W
//		CRect		&rect			[O] lp`̍W
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		SZahyoGraph*		Wz̃|C^
//----------------------------------------------------------------------------------------------------
//  5. Tv
//		m_aZahyoGraph̒Ɏw肳ꂽW܂ގlp`邩A΂̃|C^ԂB
//----------------------------------------------------------------------------------------------------
//  6. l
//----------------------------------------------------------------------------------------------------
//  7. 
//		2006.09.01 S.Aizawa(xxx) VK쐬
//*****************************************************************************************************
SZahyoDrag *CManualEditView1::CheckZahyoDrag(CPoint point, CRect &rect)
{
	CPoint pointScroll = GetScrollPosition();

	// Wz̒w肳ꂽʒu܂ގlp`
	int nSize = m_aZahyoDrag.GetSize();
	for (int i = 0; i < nSize; i++) {
		SZahyoDrag *pZahyoDrag = &m_aZahyoDrag[i];
		rect = pZahyoDrag->rect - pointScroll;
		if (rect.PtInRect(point))
			return pZahyoDrag;
	}

	return NULL;
}

SZahyoDrop *CManualEditView1::CheckZahyoDrop(CPoint point, CRect &rect)
{
	CPoint pointScroll = GetScrollPosition();

	// Wz̒w肳ꂽʒu܂ގlp`
	int nSize = m_aZahyoDrop.GetSize();
	for (int i = 0; i < nSize; i++) {
		SZahyoDrop *pZahyoDrop = &m_aZahyoDrop[i];
		rect = pZahyoDrop->rect - pointScroll;
		if (rect.PtInRect(point))
			return pZahyoDrop;
	}

	return NULL;
}

// ʍH̑IǉiANeBuʁj
void CManualEditView1::AddSelectKyotsuKotei()
{
	CManualEditDocument *pDoc = GetDocument();

	if( GetParentFrame() == pDoc->m_pSelectWnd )
		return;

	if( pDoc->m_bSelectKitting )
		return;

	BOOL bDispSagyosha = FALSE;
	int nSelectNum = pDoc->m_aSelectYosoSagyogun.GetSize();
	for( int nSelect = 0; nSelect < nSelectNum; nSelect++ ){

		if( !pDoc->m_aSelectYosoSagyogun[nSelect].bKyotsuKotei )
			continue;

		int nGroupNo = pDoc->m_aSelectYosoSagyogun[nSelect].nGroupNo;
		int nSubline = pDoc->m_aSelectYosoSagyogun[nSelect].nSublineId;

// Modify ... ( CHANGE )
		for( int nSelectSubline = 0; nSelectSubline < pDoc->m_aGraphSubline.GetSize(); nSelectSubline++ ){
			if( pDoc->m_aGraphSubline[nSelectSubline].nSublineId == pDoc->m_aSelectYosoSagyogun[nSelect].nSublineId )
				break;
		}
		if( nSelectSubline == pDoc->m_aGraphSubline.GetSize() )
			continue;
		SGraphSubline &cGraphSubline = pDoc->m_aGraphSubline[nSelectSubline];
//		SGraphSubline &cGraphSubline = pDoc->m_aGraphSubline[pDoc->m_aSelectYosoSagyogun[nSelect].nSublineId];
// By Y.Itabashi (xxxxx) 2007.03.06
		SGraphSagyosha &cGraphSagyosha = cGraphSubline.aGraphSagyosha[pDoc->m_aSelectYosoSagyogun[nSelect].nSagyoshaId];

		CGraphBlockArray &aGraphBlock = pDoc->m_nGraphKind == GRAPH_YOSO_SAGYOGUN ? cGraphSagyosha.aYosoSagyogun : cGraphSagyosha.aKotei;
		for( int nBlock = 0; nBlock < aGraphBlock.GetSize(); nBlock++ ){

			if( aGraphBlock[nBlock].nGroupNo == nGroupNo ){

				for( int nZahyoDrag = 0; nZahyoDrag < m_aZahyoDrag.GetSize(); nZahyoDrag++ ){

					if( m_aZahyoDrag[nZahyoDrag].pGraphBlock == &aGraphBlock[nBlock] ){
						pDoc->AddSelectKotei( m_aZahyoDrag[nZahyoDrag], ((CManualEditChildWnd *)GetParentFrame())->m_nGraphKishu );

						if( !bDispSagyosha ){
							DispCenterSagyosha( m_aZahyoDrag[nZahyoDrag].pGraphBlock->nSublineId, m_aZahyoDrag[nZahyoDrag].nSagyoshaId );
							bDispSagyosha = TRUE;
						}
					}
				}

			}
		}
	}
}

// QƍH̑IǉiANeBuʁj
void CManualEditView1::AddReferenceKotei()
{
	CManualEditDocument *pDoc = GetDocument();
	CManualEditChildWnd *pWnd = (CManualEditChildWnd *)GetParentFrame();

	if( GetParentFrame() == pDoc->m_pSelectWnd )
		return;

	if( pDoc->m_bSelectKitting )
		return;

	BOOL bDispSagyosha = FALSE;
	int nSelectNum = pDoc->m_aSelectYosoSagyogun.GetSize();
	for( int nSelect = 0; nSelect < nSelectNum; nSelect++ ){

		if( pDoc->m_aSelectYosoSagyogun[nSelect].nKishuId == pWnd->m_nGraphKishu )
			continue;

		CString sKoteiName = g_pDataManager->RemoveUnderbarDigit( pDoc->m_aSelectYosoSagyogun[nSelect].sKoteiName );
		CString sYosoSagyogunName = g_pDataManager->RemoveUnderbarDigit( pDoc->m_aSelectYosoSagyogun[nSelect].sYosoSagyogunName );

		for( int nBlock = 0; nBlock < m_aZahyoDrag.GetSize(); nBlock++ ){

			if( m_aZahyoDrag[nBlock].pGraphBlock->nKishuId == pDoc->m_aSelectYosoSagyogun[nSelect].nKishuId )
				continue;

			if( m_aZahyoDrag[nBlock].pGraphBlock->nSublineId != pDoc->m_aSelectYosoSagyogun[nSelect].nSublineId )
				continue;

			CString sCheckKoteiName = g_pDataManager->RemoveUnderbarDigit( m_aZahyoDrag[nBlock].pGraphBlock->sKoteiName );
			CString sCheckYosoSagyogunName = g_pDataManager->RemoveUnderbarDigit( m_aZahyoDrag[nBlock].pGraphBlock->sYosoSagyogunName );

			if( sKoteiName == sCheckKoteiName && sYosoSagyogunName == sCheckYosoSagyogunName )
				pDoc->AddReferenceKotei( m_aZahyoDrag[nBlock], pWnd->m_nGraphKishu );
		}
	}

	Invalidate();
	if( pDoc->m_aRefYosoSagyogun.GetSize() > 0 ){
		DispCenterSagyosha( pDoc->m_aRefYosoSagyogun[0].nSublineId, pDoc->m_aRefYosoSagyogun[0].nSagyoshaId );
		((CManualEditChildWnd *)GetParentFrame())->m_nRefIndex = 0;
	}
}

// LbgH̑IǉiANeBuʁj
void CManualEditView1::AddSelectKittingKotei()
{
	CManualEditDocument *pDoc = GetDocument();

// Modify ... ( CHANGE )
	CManualEditChildWnd *pWnd = (CManualEditChildWnd *)GetParentFrame();

	if( GetParentFrame() == pDoc->m_pSelectWnd && pWnd->m_nGraphKishu != -1 )
//	if( GetParentFrame() == pDoc->m_pSelectWnd )
// By Y.Itabashi (xxxxx) 2007.03.06
		return;

	if( !pDoc->m_bSelectKitting )
		return;

	BOOL bDispSagyosha = FALSE;
	int nSelectNum = pDoc->m_aSelectYosoSagyogun.GetSize();
	for( int nSelect = 0; nSelect < nSelectNum; nSelect++ ){

		if( !pDoc->m_aSelectYosoSagyogun[nSelect].bKitting )
			continue;

		SGraphSubline &cGraphSubline = pDoc->m_aGraphSubline[pDoc->m_aGraphSubline.GetSize()-1];
		SGraphSagyosha &cGraphSagyosha = cGraphSubline.aGraphSagyosha[pDoc->m_aSelectYosoSagyogun[nSelect].nSagyoshaId];

		CGraphBlockArray &aGraphBlock = pDoc->m_nGraphKind == GRAPH_YOSO_SAGYOGUN ? cGraphSagyosha.aYosoSagyogun : cGraphSagyosha.aKotei;
		for( int nBlock = 0; nBlock < aGraphBlock.GetSize(); nBlock++ ){

			if( aGraphBlock[nBlock].sKoteiName == pDoc->m_aSelectYosoSagyogun[nSelect].sKoteiName &&
				aGraphBlock[nBlock].sYosoSagyogunName == pDoc->m_aSelectYosoSagyogun[nSelect].sYosoSagyogunName ){

				for( int nZahyoDrag = 0; nZahyoDrag < m_aZahyoDrag.GetSize(); nZahyoDrag++ ){

					if( m_aZahyoDrag[nZahyoDrag].pGraphBlock == &aGraphBlock[nBlock] ){
						pDoc->AddSelectKotei( m_aZahyoDrag[nZahyoDrag], ((CManualEditChildWnd *)GetParentFrame())->m_nGraphKishu );

						if( !bDispSagyosha ){
							DispCenterSagyosha( -1, m_aZahyoDrag[nZahyoDrag].nSagyoshaId );
							bDispSagyosha = TRUE;
						}
					}
				}

			}
		}
	}
}

// H̑IǉiSʁj
void CManualEditView1::AddSelectAutiKotei()
{
	CManualEditDocument *pDoc = GetDocument();
	CManualEditChildWnd *pWnd = (CManualEditChildWnd *)GetParentFrame();

	if( pDoc->m_bSelectKitting )
		return;

	int nCheckKishu = -1;
	int nSelectNum = pDoc->m_aSelectYosoSagyogun.GetSize();
	for( int nSelect = 0; nSelect < nSelectNum; nSelect++ ){

		if( pWnd->m_nGraphKishu == pDoc->m_aSelectYosoSagyogun[nSelect].nKishuId ){

			int nIndex = ( pWnd->m_nGraphKishu == -1 ) ? pDoc->m_aSelectYosoSagyogun[nSelect].nIndex : pDoc->m_aSelectYosoSagyogun[nSelect].nIndexKishu;
			for( int nZahyoDrag = nIndex+1; nZahyoDrag < m_aZahyoDrag.GetSize(); nZahyoDrag++ ){

				if( m_aZahyoDrag[nZahyoDrag].pGraphBlock->sJido == g_pConst->m_sJido ){
					pDoc->AddSelectKotei( m_aZahyoDrag[nZahyoDrag], ((CManualEditChildWnd *)GetParentFrame())->m_nGraphKishu );
				}else
					return;
			}
		}else if( pWnd->m_nGraphKishu == -1 && nCheckKishu != pDoc->m_aSelectYosoSagyogun[nSelect].nKishuId ){

			int nIndex = ( pWnd->m_nGraphKishu == -1 ) ? pDoc->m_aSelectYosoSagyogun[nSelect].nIndex : pDoc->m_aSelectYosoSagyogun[nSelect].nIndexKishu;
			for( int nZahyoDrag = nIndex+1; nZahyoDrag < m_aZahyoDrag.GetSize(); nZahyoDrag++ ){

				if( m_aZahyoDrag[nZahyoDrag].pGraphBlock->sJido == g_pConst->m_sJido ){
					pDoc->AddSelectKotei( m_aZahyoDrag[nZahyoDrag], ((CManualEditChildWnd *)GetParentFrame())->m_nGraphKishu );
				}else
					break;
			}

			nCheckKishu = pDoc->m_aSelectYosoSagyogun[nSelect].nKishuId;
		}
	}
}
